using CellReferenceHelper = SkySof.xl.CellReferenceHelper;
using CellView = SkySof.xl.CellView;
using HeaderFooter = SkySof.xl.HeaderFooter;
using Range = SkySof.xl.Range;
using Workbook = SkySof.xl.Workbook;
using WorkbookSettings = SkySof.xl.WorkbookSettings;
using Alignment = SkySof.xl.format.Alignment;
using Border = SkySof.xl.format.Border;
using BorderLineStyle = SkySof.xl.format.BorderLineStyle;
using Color = SkySof.xl.format.Color;
using Orientation = SkySof.xl.format.Orientation;
using PageOrientation = SkySof.xl.format.PageOrientation;
using PaperSize = SkySof.xl.format.PaperSize;
using ScriptStyle = SkySof.xl.format.ScriptStyle;
using UnderlineStyle = SkySof.xl.format.UnderlineStyle;
using Boolean = SkySof.xl.write.Boolean;
using DateFormat = SkySof.xl.write.DateFormat;
using DateFormats = SkySof.xl.write.DateFormats;
using DateTime = SkySof.xl.write.DateTime;
using Formula = SkySof.xl.write.Formula;
using Label = SkySof.xl.write.Label;
using Number = SkySof.xl.write.Number;
using NumberFormat = SkySof.xl.write.NumberFormat;
using NumberFormats = SkySof.xl.write.NumberFormats;
using WritableCellFeatures = SkySof.xl.write.WritableCellFeatures;
using WritableCellFormat = SkySof.xl.write.WritableCellFormat;
using WritableFont = SkySof.xl.write.WritableFont;
using WritableHyperlink = SkySof.xl.write.WritableHyperlink;
using WritableImage = SkySof.xl.write.WritableImage;
using WritableSheet = SkySof.xl.write.WritableSheet;
using WritableWorkbook = SkySof.xl.write.WritableWorkbook;
using WriteException = SkySof.xl.write.WriteException;
using CellType = SkySof.xl.CellType;
using Sheet = SkySof.xl.Sheet;
using CellFormat = SkySof.xl.format.CellFormat;
using BiffException = SkySof.xl.read.biff.BiffException;
using Blank = SkySof.xl.write.Blank;
using WritableCell = SkySof.xl.write.WritableCell;

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace C_Sharp_Test
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		internal System.Windows.Forms.StatusBar StatusBar1;
		internal System.Windows.Forms.Button Button16;
		internal System.Windows.Forms.Button Button15;
		internal System.Windows.Forms.Button Button14;
		internal System.Windows.Forms.Button Button13;
		internal System.Windows.Forms.Button Button11;
		internal System.Windows.Forms.Button Button12;
		internal System.Windows.Forms.Button button3;
		internal System.Windows.Forms.Button Button9;
		internal System.Windows.Forms.Button Button8;
		internal System.Windows.Forms.Button Button6;
		internal System.Windows.Forms.Button Button5;
		internal System.Windows.Forms.Button Button4;
		internal System.Windows.Forms.Button button7;
		internal System.Windows.Forms.Button button10;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private string startupPath;
        internal System.Windows.Forms.CheckBox CheckBox1;
        private WebBrowser webBrowser1;
        internal Button Button18;
        internal Button Button17;
        internal Button button19;
        private Button button20;
        private ListView ListView1;
		private System.DateTime startTime; 

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			startupPath = Application.StartupPath;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.StatusBar1 = new System.Windows.Forms.StatusBar();
            this.Button16 = new System.Windows.Forms.Button();
            this.Button15 = new System.Windows.Forms.Button();
            this.Button14 = new System.Windows.Forms.Button();
            this.Button13 = new System.Windows.Forms.Button();
            this.Button11 = new System.Windows.Forms.Button();
            this.Button12 = new System.Windows.Forms.Button();
            this.button3 = new System.Windows.Forms.Button();
            this.Button9 = new System.Windows.Forms.Button();
            this.Button8 = new System.Windows.Forms.Button();
            this.Button6 = new System.Windows.Forms.Button();
            this.Button5 = new System.Windows.Forms.Button();
            this.Button4 = new System.Windows.Forms.Button();
            this.button7 = new System.Windows.Forms.Button();
            this.button10 = new System.Windows.Forms.Button();
            this.CheckBox1 = new System.Windows.Forms.CheckBox();
            this.webBrowser1 = new System.Windows.Forms.WebBrowser();
            this.Button18 = new System.Windows.Forms.Button();
            this.Button17 = new System.Windows.Forms.Button();
            this.button19 = new System.Windows.Forms.Button();
            this.button20 = new System.Windows.Forms.Button();
            this.ListView1 = new System.Windows.Forms.ListView();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(24, 176);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(272, 23);
            this.button1.TabIndex = 7;
            this.button1.Text = "Create a New Excel Workbook";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(24, 200);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(272, 23);
            this.button2.TabIndex = 8;
            this.button2.Text = "Read from Excel and Write to New Workbook";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // StatusBar1
            // 
            this.StatusBar1.Location = new System.Drawing.Point(0, 569);
            this.StatusBar1.Name = "StatusBar1";
            this.StatusBar1.Size = new System.Drawing.Size(746, 22);
            this.StatusBar1.TabIndex = 11;
            // 
            // Button16
            // 
            this.Button16.Location = new System.Drawing.Point(24, 248);
            this.Button16.Name = "Button16";
            this.Button16.Size = new System.Drawing.Size(272, 23);
            this.Button16.TabIndex = 12;
            this.Button16.Text = "Using Excel API .NET with ASP .NET";
            this.Button16.Click += new System.EventHandler(this.Button16_Click);
            // 
            // Button15
            // 
            this.Button15.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
            this.Button15.Location = new System.Drawing.Point(24, 544);
            this.Button15.Name = "Button15";
            this.Button15.Size = new System.Drawing.Size(272, 24);
            this.Button15.TabIndex = 15;
            this.Button15.Text = "Buy Excel API .NET w/xl.util namespace C# source";
            this.Button15.Click += new System.EventHandler(this.Button15_Click);
            // 
            // Button14
            // 
            this.Button14.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
            this.Button14.Location = new System.Drawing.Point(24, 520);
            this.Button14.Name = "Button14";
            this.Button14.Size = new System.Drawing.Size(272, 24);
            this.Button14.TabIndex = 14;
            this.Button14.Text = "Buy Excel API .NET through PayPal and save 15%";
            this.Button14.Click += new System.EventHandler(this.Button14_Click);
            // 
            // Button13
            // 
            this.Button13.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
            this.Button13.Location = new System.Drawing.Point(24, 496);
            this.Button13.Name = "Button13";
            this.Button13.Size = new System.Drawing.Size(272, 24);
            this.Button13.TabIndex = 13;
            this.Button13.Text = "Buy Excel API .NET through RegNow";
            this.Button13.Click += new System.EventHandler(this.Button13_Click);
            // 
            // Button11
            // 
            this.Button11.Location = new System.Drawing.Point(23, 80);
            this.Button11.Name = "Button11";
            this.Button11.Size = new System.Drawing.Size(272, 23);
            this.Button11.TabIndex = 3;
            this.Button11.Text = "Create Styled HTML File from Excel Worksheet";
            this.Button11.Click += new System.EventHandler(this.Button11_Click);
            // 
            // Button12
            // 
            this.Button12.Location = new System.Drawing.Point(23, 56);
            this.Button12.Name = "Button12";
            this.Button12.Size = new System.Drawing.Size(272, 23);
            this.Button12.TabIndex = 2;
            this.Button12.Text = "Create Styled HTML Table from Excel Worksheet";
            this.Button12.Click += new System.EventHandler(this.Button12_Click);
            // 
            // button3
            // 
            this.button3.Location = new System.Drawing.Point(104, 224);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(120, 23);
            this.button3.TabIndex = 10;
            this.button3.Text = "Escher Drawing Data";
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // Button9
            // 
            this.Button9.Location = new System.Drawing.Point(23, 32);
            this.Button9.Name = "Button9";
            this.Button9.Size = new System.Drawing.Size(272, 23);
            this.Button9.TabIndex = 1;
            this.Button9.Text = "Create HTML File from Excel Worksheet";
            this.Button9.Click += new System.EventHandler(this.Button9_Click);
            // 
            // Button8
            // 
            this.Button8.Location = new System.Drawing.Point(23, 8);
            this.Button8.Name = "Button8";
            this.Button8.Size = new System.Drawing.Size(272, 23);
            this.Button8.TabIndex = 0;
            this.Button8.Text = "Create HTML Table from Excel Worksheet";
            this.Button8.Click += new System.EventHandler(this.Button8_Click);
            // 
            // Button6
            // 
            this.Button6.Location = new System.Drawing.Point(23, 128);
            this.Button6.Name = "Button6";
            this.Button6.Size = new System.Drawing.Size(272, 23);
            this.Button6.TabIndex = 5;
            this.Button6.Text = "Create XML File from Excel Worksheet";
            this.Button6.Click += new System.EventHandler(this.Button6_Click);
            // 
            // Button5
            // 
            this.Button5.Location = new System.Drawing.Point(231, 224);
            this.Button5.Name = "Button5";
            this.Button5.Size = new System.Drawing.Size(64, 23);
            this.Button5.TabIndex = 11;
            this.Button5.Text = "BiffDump";
            this.Button5.Click += new System.EventHandler(this.Button5_Click);
            // 
            // Button4
            // 
            this.Button4.Location = new System.Drawing.Point(23, 104);
            this.Button4.Name = "Button4";
            this.Button4.Size = new System.Drawing.Size(272, 23);
            this.Button4.TabIndex = 4;
            this.Button4.Text = "Create CSV File from Excel Worksheet";
            this.Button4.Click += new System.EventHandler(this.Button4_Click);
            // 
            // button7
            // 
            this.button7.Location = new System.Drawing.Point(23, 224);
            this.button7.Name = "button7";
            this.button7.Size = new System.Drawing.Size(75, 23);
            this.button7.TabIndex = 9;
            this.button7.Text = "Escher Data";
            this.button7.Click += new System.EventHandler(this.button7_Click);
            // 
            // button10
            // 
            this.button10.Location = new System.Drawing.Point(23, 152);
            this.button10.Name = "button10";
            this.button10.Size = new System.Drawing.Size(272, 23);
            this.button10.TabIndex = 6;
            this.button10.Text = "Read Excel Cell Data";
            this.button10.Click += new System.EventHandler(this.button10_Click);
            // 
            // CheckBox1
            // 
            this.CheckBox1.Location = new System.Drawing.Point(312, 8);
            this.CheckBox1.Name = "CheckBox1";
            this.CheckBox1.Size = new System.Drawing.Size(424, 16);
            this.CheckBox1.TabIndex = 18;
            this.CheckBox1.Text = "Open file in WebBrowser control below";
            // 
            // webBrowser1
            // 
            this.webBrowser1.Location = new System.Drawing.Point(312, 30);
            this.webBrowser1.MinimumSize = new System.Drawing.Size(20, 20);
            this.webBrowser1.Name = "webBrowser1";
            this.webBrowser1.Size = new System.Drawing.Size(422, 538);
            this.webBrowser1.TabIndex = 19;
            // 
            // Button18
            // 
            this.Button18.Location = new System.Drawing.Point(23, 296);
            this.Button18.Name = "Button18";
            this.Button18.Size = new System.Drawing.Size(268, 24);
            this.Button18.TabIndex = 24;
            this.Button18.Text = "Move Excel Data to Data Reader";
            this.Button18.UseVisualStyleBackColor = true;
            this.Button18.Click += new System.EventHandler(this.Button18_Click);
            // 
            // Button17
            // 
            this.Button17.Location = new System.Drawing.Point(24, 272);
            this.Button17.Name = "Button17";
            this.Button17.Size = new System.Drawing.Size(268, 24);
            this.Button17.TabIndex = 23;
            this.Button17.Text = "Move Excel Data to Data Adapter";
            this.Button17.UseVisualStyleBackColor = true;
            this.Button17.Click += new System.EventHandler(this.Button17_Click);
            // 
            // button19
            // 
            this.button19.Location = new System.Drawing.Point(23, 320);
            this.button19.Name = "button19";
            this.button19.Size = new System.Drawing.Size(268, 24);
            this.button19.TabIndex = 25;
            this.button19.Text = "Move Excel Data to a Collection";
            this.button19.UseVisualStyleBackColor = true;
            this.button19.Click += new System.EventHandler(this.button19_Click);
            // 
            // button20
            // 
            this.button20.Location = new System.Drawing.Point(24, 346);
            this.button20.Name = "button20";
            this.button20.Size = new System.Drawing.Size(266, 25);
            this.button20.TabIndex = 26;
            this.button20.Text = "Move Excel Data to ListView";
            this.button20.UseVisualStyleBackColor = true;
            this.button20.Click += new System.EventHandler(this.button20_Click);
            // 
            // ListView1
            // 
            this.ListView1.Location = new System.Drawing.Point(27, 385);
            this.ListView1.Name = "ListView1";
            this.ListView1.Size = new System.Drawing.Size(267, 97);
            this.ListView1.TabIndex = 27;
            this.ListView1.UseCompatibleStateImageBehavior = false;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(746, 591);
            this.Controls.Add(this.ListView1);
            this.Controls.Add(this.button20);
            this.Controls.Add(this.button19);
            this.Controls.Add(this.Button18);
            this.Controls.Add(this.Button17);
            this.Controls.Add(this.webBrowser1);
            this.Controls.Add(this.CheckBox1);
            this.Controls.Add(this.Button16);
            this.Controls.Add(this.Button15);
            this.Controls.Add(this.Button14);
            this.Controls.Add(this.Button13);
            this.Controls.Add(this.Button11);
            this.Controls.Add(this.Button12);
            this.Controls.Add(this.button3);
            this.Controls.Add(this.Button9);
            this.Controls.Add(this.Button8);
            this.Controls.Add(this.Button6);
            this.Controls.Add(this.Button5);
            this.Controls.Add(this.Button4);
            this.Controls.Add(this.button7);
            this.Controls.Add(this.button10);
            this.Controls.Add(this.StatusBar1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Excel API .NET C# Demo";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
		
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		
		}

        private WritableWorkbook workbook;

		private void button1_Click(object sender, System.EventArgs e)
		{
			System.String filename;
		    filename = startupPath + "\\newwb.xls";
			System.Console.WriteLine("Building workbook...");
			startTime = System.DateTime.Now; 
            write(filename);
            StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
            System.Console.WriteLine("Created " + filename);
            System.Diagnostics.Process.Start(filename);
            MessageBox.Show("Created " + filename);

		}

		private void write(System.String filename)
		{
			WorkbookSettings ws = new WorkbookSettings();
			ws.setLocale(new System.Globalization.CultureInfo("en-US"));
			workbook = Workbook.createWorkbook(new System.IO.FileInfo(filename), ws);			
			
			WritableSheet s2 = workbook.createSheet("Number Formats", 0);
			WritableSheet s3 = workbook.createSheet("Date Formats", 1);
			WritableSheet s1 = workbook.createSheet("Label Formats", 2);
			WritableSheet s4 = workbook.createSheet("Borders", 3);
			WritableSheet s5 = workbook.createSheet("Labels", 4);
			WritableSheet s6 = workbook.createSheet("Formulas", 5);
			WritableSheet s7 = workbook.createSheet("Images", 6);
			//    WritableSheet s8 = workbook.createSheet
			//      ("'Illegal chars in name !*%^?': which exceeds max name length",7);
			writeLabelFormatSheet(s1);            
			writeNumberFormatSheet(s2);
			writeDateFormatSheet(s3);
			writeBordersSheet(s4);
			writeLabelsSheet(s5);            
			writeFormulaSheet(s6);
			writeImageSheet(s7);
			
            
			// Modify the color palette to bright red for the lime color
			workbook.setColorRGB(Color.LIME, 0xff, 0, 0);
			
			// Add a named range to the workbook
			workbook.addNameArea("namedrange", s4, 1, 11, 5, 14);
			
			workbook.write();
			workbook.close();
		}

		private void  writeNumberFormatSheet(WritableSheet s)
		{
			WritableCellFormat wrappedText = new WritableCellFormat(WritableWorkbook.ARIAL_10_PT);
			wrappedText.setWrap(true);
			
			s.setColumnView(0, 20);
			s.setColumnView(4, 20);
			s.setColumnView(5, 20);
			s.setColumnView(6, 20);
			
			// Floats
			Label l = new Label(0, 0, "+/- Pi - default format", wrappedText);
			s.addCell(l);
			
			Number n = new Number(1, 0, 3.1415926535);
			s.addCell(n);
			
			n = new Number(2, 0, - 3.1415926535);
			s.addCell(n);
			
			l = new Label(0, 1, "+/- Pi - integer format", wrappedText);
			s.addCell(l);
			
			WritableCellFormat cf1 = new WritableCellFormat(NumberFormats.INTEGER);
			n = new Number(1, 1, 3.1415926535, cf1);
			s.addCell(n);
			
			n = new Number(2, 1, - 3.1415926535, cf1);
			s.addCell(n);
			
			l = new Label(0, 2, "+/- Pi - float 2dps", wrappedText);
			s.addCell(l);
			
			WritableCellFormat cf2 = new WritableCellFormat(NumberFormats.FLOAT);
			n = new Number(1, 2, 3.1415926535, cf2);
			s.addCell(n);
			
			n = new Number(2, 2, - 3.1415926535, cf2);
			s.addCell(n);
			
			l = new Label(0, 3, "+/- Pi - custom 3dps", wrappedText);
			s.addCell(l);
			
			NumberFormat dp3 = new NumberFormat("#.###");
			WritableCellFormat dp3cell = new WritableCellFormat(dp3);
			n = new Number(1, 3, 3.1415926535, dp3cell);
			s.addCell(n);
			
			n = new Number(2, 3, - 3.1415926535, dp3cell);
			s.addCell(n);
			
			l = new Label(0, 4, "+/- Pi - custom &3.14", wrappedText);
			s.addCell(l);
			
			NumberFormat pounddp2 = new NumberFormat("&#.00");
			WritableCellFormat pounddp2cell = new WritableCellFormat(pounddp2);
			n = new Number(1, 4, 3.1415926535, pounddp2cell);
			s.addCell(n);
			
			n = new Number(2, 4, - 3.1415926535, pounddp2cell);
			s.addCell(n);
			
			l = new Label(0, 5, "+/- Pi - custom Text #.### Text", wrappedText);
			s.addCell(l);
			
			NumberFormat textdp4 = new NumberFormat("Text#.####Text");
			WritableCellFormat textdp4cell = new WritableCellFormat(textdp4);
			n = new Number(1, 5, 3.1415926535, textdp4cell);
			s.addCell(n);
			
			n = new Number(2, 5, - 3.1415926535, textdp4cell);
			s.addCell(n);
			
			// Integers
			l = new Label(4, 0, "+/- Bilko default format");
			s.addCell(l);
			n = new Number(5, 0, 15042699);
			s.addCell(n);
			n = new Number(6, 0, - 15042699);
			s.addCell(n);
			
			l = new Label(4, 1, "+/- Bilko float format");
			s.addCell(l);
			WritableCellFormat cfi1 = new WritableCellFormat(NumberFormats.FLOAT);
			n = new Number(5, 1, 15042699, cfi1);
			s.addCell(n);
			n = new Number(6, 1, - 15042699, cfi1);
			s.addCell(n);
			
			l = new Label(4, 2, "+/- Thousands separator");
			s.addCell(l);
			WritableCellFormat cfi2 = new WritableCellFormat(NumberFormats.THOUSANDS_INTEGER);
			n = new Number(5, 2, 15042699, cfi2);
			s.addCell(n);
			n = new Number(6, 2, - 15042699, cfi2);
			s.addCell(n);
			
			l = new Label(4, 3, "+/- Accounting red - added 0.01");
			s.addCell(l);
			WritableCellFormat cfi3 = new WritableCellFormat(NumberFormats.ACCOUNTING_RED_FLOAT);
			n = new Number(5, 3, 15042699.01, cfi3);
			s.addCell(n);
			n = new Number(6, 3, - 15042699.01, cfi3);
			s.addCell(n);
			
			l = new Label(4, 4, "+/- Percent");
			s.addCell(l);
			WritableCellFormat cfi4 = new WritableCellFormat(NumberFormats.PERCENT_INTEGER);
			n = new Number(5, 4, 15042699, cfi4);
			s.addCell(n);
			n = new Number(6, 4, - 15042699, cfi4);
			s.addCell(n);
			
			l = new Label(4, 5, "+/- Exponential - 2dps");
			s.addCell(l);
			WritableCellFormat cfi5 = new WritableCellFormat(NumberFormats.EXPONENTIAL);
			n = new Number(5, 5, 15042699, cfi5);
			s.addCell(n);
			n = new Number(6, 5, - 15042699, cfi5);
			s.addCell(n);
			
			l = new Label(4, 6, "+/- Custom exponentional - 3dps", wrappedText);
			s.addCell(l);
			NumberFormat edp3 = new NumberFormat("0.000E0");
			WritableCellFormat edp3Cell = new WritableCellFormat(edp3);
			n = new Number(5, 6, 15042699, edp3Cell);
			s.addCell(n);
			n = new Number(6, 6, - 15042699, edp3Cell);
			s.addCell(n);
			
			l = new Label(4, 7, "Custom neg brackets", wrappedText);
			s.addCell(l);
			NumberFormat negbracks = new NumberFormat("#,##0;(#,##0)");
			WritableCellFormat negbrackscell = new WritableCellFormat(negbracks);
			n = new Number(5, 7, 15042699, negbrackscell);
			s.addCell(n);
			n = new Number(6, 7, - 15042699, negbrackscell);
			s.addCell(n);
			
			l = new Label(4, 8, "Custom neg brackets 2", wrappedText);
			s.addCell(l);
			NumberFormat negbracks2 = new NumberFormat("#,##0;(#,##0)a");
			WritableCellFormat negbrackscell2 = new WritableCellFormat(negbracks2);
			n = new Number(5, 8, 15042699, negbrackscell2);
			s.addCell(n);
			n = new Number(6, 8, - 15042699, negbrackscell2);
			s.addCell(n);
			
			l = new Label(4, 9, "Custom percent", wrappedText);
			s.addCell(l);
			NumberFormat cuspercent = new NumberFormat("0.0%");
			WritableCellFormat cuspercentf = new WritableCellFormat(cuspercent);
			n = new Number(5, 9, 3.14159265, cuspercentf);
			s.addCell(n);
			
			// Booleans
			l = new Label(0, 10, "Boolean - TRUE");
			s.addCell(l);
			Boolean b = new Boolean(1, 10, true);
			s.addCell(b);
			
			l = new Label(0, 11, "Boolean - FALSE");
			s.addCell(l);
			b = new Boolean(1, 11, false);
			s.addCell(b);
			
			l = new Label(0, 12, "A hidden cell->");
			s.addCell(l);
			n = new Number(1, 12, 17, WritableWorkbook.HIDDEN_STYLE);
			s.addCell(n);
			
			// Currencies
			l = new Label(4, 19, "Currency formats");
			s.addCell(l);
			
			l = new Label(4, 21, "UK Pound");
			s.addCell(l);
			NumberFormat poundCurrency = new NumberFormat(NumberFormat.CURRENCY_POUND + " #,###.00", NumberFormat.COMPLEX_FORMAT);
			WritableCellFormat poundFormat = new WritableCellFormat(poundCurrency);
			n = new Number(5, 21, 12345, poundFormat);
			s.addCell(n);
			
			l = new Label(4, 22, "Euro 1");
			s.addCell(l);
			NumberFormat euroPrefixCurrency = new NumberFormat(NumberFormat.CURRENCY_EURO_PREFIX + " #,###.00", NumberFormat.COMPLEX_FORMAT);
			WritableCellFormat euroPrefixFormat = new WritableCellFormat(euroPrefixCurrency);
			n = new Number(5, 22, 12345, euroPrefixFormat);
			s.addCell(n);
			
			l = new Label(4, 23, "Euro 2");
			s.addCell(l);
			NumberFormat euroSuffixCurrency = new NumberFormat("#,###.00" + NumberFormat.CURRENCY_EURO_SUFFIX, NumberFormat.COMPLEX_FORMAT);
			WritableCellFormat euroSuffixFormat = new WritableCellFormat(euroSuffixCurrency);
			n = new Number(5, 23, 12345, euroSuffixFormat);
			s.addCell(n);
			
			l = new Label(4, 24, "Dollar");
			s.addCell(l);
			NumberFormat dollarCurrency = new NumberFormat(NumberFormat.CURRENCY_DOLLAR + " #,###.00", NumberFormat.COMPLEX_FORMAT);
			WritableCellFormat dollarFormat = new WritableCellFormat(dollarCurrency);
			n = new Number(5, 24, 12345, dollarFormat);
			s.addCell(n);
			
			l = new Label(4, 25, "Japanese Yen");
			s.addCell(l);
			NumberFormat japaneseYenCurrency = new NumberFormat(NumberFormat.CURRENCY_JAPANESE_YEN + " #,###.00", NumberFormat.COMPLEX_FORMAT);
			WritableCellFormat japaneseYenFormat = new WritableCellFormat(japaneseYenCurrency);
			n = new Number(5, 25, 12345, japaneseYenFormat);
			s.addCell(n);
			
			l = new Label(4, 30, "Fraction formats");
			s.addCell(l);
			
			l = new Label(4, 32, "One digit fraction format", wrappedText);
			s.addCell(l);
			
			WritableCellFormat fraction1digitformat = new WritableCellFormat(NumberFormats.FRACTION_ONE_DIGIT);
			n = new Number(5, 32, 3.18279, fraction1digitformat);
			s.addCell(n);
			
			l = new Label(4, 33, "Two digit fraction format", wrappedText);
			s.addCell(l);
			
			WritableCellFormat fraction2digitformat = new WritableCellFormat(NumberFormats.FRACTION_TWO_DIGITS);
			n = new Number(5, 33, 3.18279, fraction2digitformat);
			s.addCell(n);
			
			l = new Label(4, 34, "Three digit fraction format (improper)", wrappedText);
			s.addCell(l);
			
			NumberFormat fraction3digit1 = new NumberFormat(NumberFormat.FRACTION_THREE_DIGITS, NumberFormat.COMPLEX_FORMAT);
			WritableCellFormat fraction3digitformat1 = new WritableCellFormat(fraction3digit1);
			n = new Number(5, 34, 3.18927, fraction3digitformat1);
			s.addCell(n);
			
			l = new Label(4, 35, "Three digit fraction format (proper)", wrappedText);
			s.addCell(l);
			
			NumberFormat fraction3digit2 = new NumberFormat("# " + NumberFormat.FRACTION_THREE_DIGITS, NumberFormat.COMPLEX_FORMAT);
			WritableCellFormat fraction3digitformat2 = new WritableCellFormat(fraction3digit2);
			n = new Number(5, 35, 3.18927, fraction3digitformat2);
			s.addCell(n);
			
			// Lots of numbers
			for (int row = 0; row < 100; row++)
			{
				for (int col = 8; col < 108; col++)
				{
					n = new Number(col, row, col + row);
					s.addCell(n);
				}
			}
			
			// Lots of numbers
			for (int row = 101; row < 3000; row++)
			{
				for (int col = 0; col < 25; col++)
				{
					n = new Number(col, row, col + row);
					s.addCell(n);
				}
			}
		}
		
		// Adds cells to the specified sheet which test the various date formats
		private void  writeDateFormatSheet(WritableSheet s)
		{
			WritableCellFormat wrappedText = new WritableCellFormat(WritableWorkbook.ARIAL_10_PT);
			wrappedText.setWrap(true);
			
			s.setColumnView(0, 20);
			s.setColumnView(2, 20);
			s.setColumnView(3, 20);
			s.setColumnView(4, 20);
			
			s.getSettings().setFitWidth(2);
			s.getSettings().setFitHeight(2);
			
			System.Globalization.Calendar c = new System.Globalization.GregorianCalendar();
			SupportClass.CalendarManager.manager.Set(c, 1975, 4, 31, 15, 21, 45);
			SupportClass.CalendarManager.manager.Set(c, SupportClass.CalendarManager.MILLISECOND, 660);
			System.DateTime date = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1900, 0, 1, 0, 0, 0);
			SupportClass.CalendarManager.manager.Set(c, SupportClass.CalendarManager.MILLISECOND, 0);
			
			System.DateTime date2 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1970, 0, 1, 0, 0, 0);
			System.DateTime date3 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1918, 10, 11, 11, 0, 0);
			System.DateTime date4 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1900, 0, 2, 0, 0, 0);
			System.DateTime date5 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1901, 0, 1, 0, 0, 0);
			System.DateTime date6 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1900, 4, 31, 0, 0, 0);
			System.DateTime date7 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1900, 1, 1, 0, 0, 0);
			System.DateTime date8 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1900, 0, 31, 0, 0, 0);
			System.DateTime date9 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1900, 2, 1, 0, 0, 0);
			System.DateTime date10 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1900, 1, 27, 0, 0, 0);
			System.DateTime date11 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1900, 1, 28, 0, 0, 0);
			System.DateTime date12 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1980, 5, 31, 12, 0, 0);
			System.DateTime date13 = SupportClass.CalendarManager.manager.GetDateTime(c);
			SupportClass.CalendarManager.manager.Set(c, 1066, 9, 14, 0, 0, 0);
			System.DateTime date14 = SupportClass.CalendarManager.manager.GetDateTime(c);
			
			// Built in date formats
			SimpleDateFormat sdf = new SimpleDateFormat("dd MMM yyyy HH:mm:ss.SSS");
			//sdf.setTimeZone(TimeZone.CurrentTimeZone);
			Label l = new Label(0, 0, "All dates are " + date.ToString(sdf), wrappedText);
			s.addCell(l);
			
			l = new Label(0, 1, "Built in formats", wrappedText);
			s.addCell(l);
			
			l = new Label(2, 1, "Custom formats");
			s.addCell(l);
			
			WritableCellFormat cf1 = new WritableCellFormat(DateFormats.FORMAT1);
			DateTime dt = new DateTime(0, 2, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT2);
			dt = new DateTime(0, 3, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT3);
			dt = new DateTime(0, 4, ref date, cf1);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT4);
			dt = new DateTime(0, 5, ref date, cf1);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT5);
			dt = new DateTime(0, 6, ref date, cf1);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT6);
			dt = new DateTime(0, 7, ref date, cf1);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT7);
			dt = new DateTime(0, 8, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT8);
			dt = new DateTime(0, 9, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(0, 10, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT10);
			dt = new DateTime(0, 11, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT11);
			dt = new DateTime(0, 12, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT12);
			dt = new DateTime(0, 13, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Custom formats
			DateFormat df = new DateFormat("dd MM yyyy");
			cf1 = new WritableCellFormat(df);
			l = new Label(2, 2, "dd MM yyyy");
			s.addCell(l);
			
			dt = new DateTime(3, 2, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			df = new DateFormat("dd MMM yyyy");
			cf1 = new WritableCellFormat(df);
			l = new Label(2, 3, "dd MMM yyyy");
			s.addCell(l);
			
			dt = new DateTime(3, 3, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			df = new DateFormat("hh:mm");
			cf1 = new WritableCellFormat(df);
			l = new Label(2, 4, "hh:mm");
			s.addCell(l);
			
			dt = new DateTime(3, 4, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			df = new DateFormat("hh:mm:ss");
			cf1 = new WritableCellFormat(df);
			l = new Label(2, 5, "hh:mm:ss");
			s.addCell(l);
			
			dt = new DateTime(3, 5, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			df = new DateFormat("H:mm:ss a");
			cf1 = new WritableCellFormat(df);
			l = new Label(2, 5, "H:mm:ss a");
			s.addCell(l);
			
			dt = new DateTime(3, 5, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			dt = new DateTime(4, 5, ref date13, cf1, DateTime.GMT);
			s.addCell(dt);
			
			df = new DateFormat("mm:ss.SSS");
			cf1 = new WritableCellFormat(df);
			l = new Label(2, 6, "mm:ss.SSS");
			s.addCell(l);
			
			dt = new DateTime(3, 6, ref date, cf1, DateTime.GMT);
			s.addCell(dt);
			
			df = new DateFormat("hh:mm:ss a");
			cf1 = new WritableCellFormat(df);
			l = new Label(2, 7, "hh:mm:ss a");
			s.addCell(l);
			
			dt = new DateTime(4, 7, ref date13, cf1, DateTime.GMT);
			s.addCell(dt);

			// Check out the zero date ie. 1 Jan 1900
			l = new Label(0, 16, "Zero date " + date2.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(0, 17, ref date2, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out the zero date + 1 ie. 2 Jan 1900
			l = new Label(3, 16, "Zero date + 1 " + date5.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(3, 17, ref date5, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out the 1 Jan 1901
			l = new Label(3, 19, date6.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(3, 20, ref date6, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out the 31 May 1900
			l = new Label(3, 22, date7.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(3, 23, ref date7, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out 1 Feb 1900
			l = new Label(3, 25, date8.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(3, 26, ref date8, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out 31 Jan 1900
			l = new Label(3, 28, date9.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(3, 29, ref date9, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out 31 Jan 1900
			l = new Label(3, 28, date9.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(3, 29, ref date9, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out 1 Mar 1900
			l = new Label(3, 31, date10.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(3, 32, ref date10, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out 27 Feb 1900
			l = new Label(3, 34, date11.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(3, 35, ref date11, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out 28 Feb 1900
			l = new Label(3, 37, date12.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(3, 38, ref date12, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out the zero date ie. 1 Jan 1970
			l = new Label(0, 19, "Zero UTC date " + date3.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(0, 20, ref date3, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out the WWI armistice day ie. 11 am, Nov 11, 1918
			l = new Label(0, 22, "Armistice date " + date4.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT9);
			dt = new DateTime(0, 23, ref date4, cf1, DateTime.GMT);
			s.addCell(dt);
			
			// Check out the Battle of Hastings date Oct 14th, 1066
			l = new Label(0, 25, "Battle of Hastings " + date14.ToString(sdf), wrappedText);
			s.addCell(l);
			
			cf1 = new WritableCellFormat(DateFormats.FORMAT2);
			dt = new DateTime(0, 26, ref date14, cf1, DateTime.GMT);
			s.addCell(dt);
		}
		
		// Adds cells to the specified sheet which test the various label formatting
		// styles, such as different fonts, different sizes and bold, underline etc.
		private void  writeLabelFormatSheet(WritableSheet s1)
		{
			s1.setColumnView(0, 60);
			
			Label lr = new Label(0, 0, "Arial Fonts");
			s1.addCell(lr);
			
			lr = new Label(1, 0, "10pt");
			s1.addCell(lr);
			
			lr = new Label(2, 0, "Normal");
			s1.addCell(lr);
			
			lr = new Label(3, 0, "12pt");
			s1.addCell(lr);
			
			WritableFont arial12pt = new WritableFont(WritableFont.ARIAL, 12);
			WritableCellFormat arial12format = new WritableCellFormat(arial12pt);
			arial12format.setWrap(true);
			lr = new Label(4, 0, "Normal", arial12format);
			s1.addCell(lr);
			
			WritableFont arial10ptBold = new WritableFont(WritableFont.ARIAL, 10, WritableFont.BOLD);
			WritableCellFormat arial10BoldFormat = new WritableCellFormat(arial10ptBold);
			lr = new Label(2, 2, "BOLD", arial10BoldFormat);
			s1.addCell(lr);
			
			WritableFont arial12ptBold = new WritableFont(WritableFont.ARIAL, 12, WritableFont.BOLD);
			WritableCellFormat arial12BoldFormat = new WritableCellFormat(arial12ptBold);
			lr = new Label(4, 2, "BOLD", arial12BoldFormat);
			s1.addCell(lr);
			
			WritableFont arial10ptItalic = new WritableFont(WritableFont.ARIAL, 10, WritableFont.NO_BOLD, true);
			WritableCellFormat arial10ItalicFormat = new WritableCellFormat(arial10ptItalic);
			lr = new Label(2, 4, "Italic", arial10ItalicFormat);
			s1.addCell(lr);
			
			WritableFont arial12ptItalic = new WritableFont(WritableFont.ARIAL, 12, WritableFont.NO_BOLD, true);
			WritableCellFormat arial12ptItalicFormat = new WritableCellFormat(arial12ptItalic);
			lr = new Label(4, 4, "Italic", arial12ptItalicFormat);
			s1.addCell(lr);
			
			WritableFont times10pt = new WritableFont(WritableFont.TIMES, 10);
			WritableCellFormat times10format = new WritableCellFormat(times10pt);
			lr = new Label(0, 7, "Times Fonts", times10format);
			s1.addCell(lr);
			
			lr = new Label(1, 7, "10pt", times10format);
			s1.addCell(lr);
			
			lr = new Label(2, 7, "Normal", times10format);
			s1.addCell(lr);
			
			lr = new Label(3, 7, "12pt", times10format);
			s1.addCell(lr);
			
			WritableFont times12pt = new WritableFont(WritableFont.TIMES, 12);
			WritableCellFormat times12format = new WritableCellFormat(times12pt);
			lr = new Label(4, 7, "Normal", times12format);
			s1.addCell(lr);
			
			WritableFont times10ptBold = new WritableFont(WritableFont.TIMES, 10, WritableFont.BOLD);
			WritableCellFormat times10BoldFormat = new WritableCellFormat(times10ptBold);
			lr = new Label(2, 9, "BOLD", times10BoldFormat);
			s1.addCell(lr);
			
			WritableFont times12ptBold = new WritableFont(WritableFont.TIMES, 12, WritableFont.BOLD);
			WritableCellFormat times12BoldFormat = new WritableCellFormat(times12ptBold);
			lr = new Label(4, 9, "BOLD", times12BoldFormat);
			s1.addCell(lr);
			
			// The underline styles
			s1.setColumnView(6, 22);
			s1.setColumnView(7, 22);
			s1.setColumnView(8, 22);
			s1.setColumnView(9, 22);
			
			lr = new Label(0, 11, "Underlining");
			s1.addCell(lr);
			
			WritableFont arial10ptUnderline = new WritableFont(WritableFont.ARIAL, WritableFont.DEFAULT_POINT_SIZE, WritableFont.NO_BOLD, false, UnderlineStyle.SINGLE);
			WritableCellFormat arialUnderline = new WritableCellFormat(arial10ptUnderline);
			lr = new Label(6, 11, "Underline", arialUnderline);
			s1.addCell(lr);
			
			WritableFont arial10ptDoubleUnderline = new WritableFont(WritableFont.ARIAL, WritableFont.DEFAULT_POINT_SIZE, WritableFont.NO_BOLD, false, UnderlineStyle.DOUBLE);
			WritableCellFormat arialDoubleUnderline = new WritableCellFormat(arial10ptDoubleUnderline);
			lr = new Label(7, 11, "Double Underline", arialDoubleUnderline);
			s1.addCell(lr);
			
			WritableFont arial10ptSingleAcc = new WritableFont(WritableFont.ARIAL, WritableFont.DEFAULT_POINT_SIZE, WritableFont.NO_BOLD, false, UnderlineStyle.SINGLE_ACCOUNTING);
			WritableCellFormat arialSingleAcc = new WritableCellFormat(arial10ptSingleAcc);
			lr = new Label(8, 11, "Single Accounting Underline", arialSingleAcc);
			s1.addCell(lr);
			
			WritableFont arial10ptDoubleAcc = new WritableFont(WritableFont.ARIAL, WritableFont.DEFAULT_POINT_SIZE, WritableFont.NO_BOLD, false, UnderlineStyle.DOUBLE_ACCOUNTING);
			WritableCellFormat arialDoubleAcc = new WritableCellFormat(arial10ptDoubleAcc);
			lr = new Label(9, 11, "Double Accounting Underline", arialDoubleAcc);
			s1.addCell(lr);
			
			WritableFont times14ptBoldUnderline = new WritableFont(WritableFont.TIMES, 14, WritableFont.BOLD, false, UnderlineStyle.SINGLE);
			WritableCellFormat timesBoldUnderline = new WritableCellFormat(times14ptBoldUnderline);
			lr = new Label(6, 12, "Times 14 Bold Underline", timesBoldUnderline);
			s1.addCell(lr);
			
			WritableFont arial18ptBoldItalicUnderline = new WritableFont(WritableFont.ARIAL, 18, WritableFont.BOLD, true, UnderlineStyle.SINGLE);
			WritableCellFormat arialBoldItalicUnderline = new WritableCellFormat(arial18ptBoldItalicUnderline);
			lr = new Label(6, 13, "Arial 18 Bold Italic Underline", arialBoldItalicUnderline);
			s1.addCell(lr);
			
			lr = new Label(0, 15, "Script styles");
			s1.addCell(lr);
			
			WritableFont superscript = new WritableFont(WritableFont.ARIAL, WritableFont.DEFAULT_POINT_SIZE, WritableFont.NO_BOLD, false, UnderlineStyle.NO_UNDERLINE, Color.BLACK, ScriptStyle.SUPERSCRIPT);
			WritableCellFormat superscriptFormat = new WritableCellFormat(superscript);
			lr = new Label(1, 15, "superscript", superscriptFormat);
			s1.addCell(lr);
			
			WritableFont subscript = new WritableFont(WritableFont.ARIAL, WritableFont.DEFAULT_POINT_SIZE, WritableFont.NO_BOLD, false, UnderlineStyle.NO_UNDERLINE, Color.BLACK, ScriptStyle.SUBSCRIPT);
			WritableCellFormat subscriptFormat = new WritableCellFormat(subscript);
			lr = new Label(2, 15, "subscript", subscriptFormat);
			s1.addCell(lr);
			
			lr = new Label(0, 17, "Colors");
			s1.addCell(lr);
			
			WritableFont red = new WritableFont(WritableFont.ARIAL, WritableFont.DEFAULT_POINT_SIZE, WritableFont.NO_BOLD, false, UnderlineStyle.NO_UNDERLINE, Color.RED);
			WritableCellFormat redFormat = new WritableCellFormat(red);
			lr = new Label(2, 17, "Red", redFormat);
			s1.addCell(lr);
			
			WritableFont blue = new WritableFont(WritableFont.ARIAL, WritableFont.DEFAULT_POINT_SIZE, WritableFont.NO_BOLD, false, UnderlineStyle.NO_UNDERLINE, Color.BLUE);
			WritableCellFormat blueFormat = new WritableCellFormat(blue);
			lr = new Label(2, 18, "Blue", blueFormat);
			s1.addCell(lr);
			
			WritableFont lime = new WritableFont(WritableFont.ARIAL);
			lime.setColor(Color.LIME);
			WritableCellFormat limeFormat = new WritableCellFormat(lime);
			limeFormat.setWrap(true);
			lr = new Label(4, 18, "Modified palette - was lime, now red", limeFormat);
			s1.addCell(lr);
			
			WritableCellFormat greyBackground = new WritableCellFormat();
			greyBackground.setWrap(true);
			greyBackground.setBackground(Color.GRAY_50);
			lr = new Label(2, 19, "Grey background", greyBackground);
			s1.addCell(lr);
			
			WritableFont yellow = new WritableFont(WritableFont.ARIAL, WritableFont.DEFAULT_POINT_SIZE, WritableFont.NO_BOLD, false, UnderlineStyle.NO_UNDERLINE, Color.YELLOW);
			WritableCellFormat yellowOnBlue = new WritableCellFormat(yellow);
			yellowOnBlue.setWrap(true);
			yellowOnBlue.setBackground(Color.BLUE);
			lr = new Label(2, 20, "Blue background, yellow foreground", yellowOnBlue);
			s1.addCell(lr);
			
			lr = new Label(0, 22, "Null label");
			s1.addCell(lr);
			
			//lr = new Label(2, 22, (Label)null);
			//s1.addCell(lr);
			
			lr = new Label(0, 24, "A very long label, more than 255 characters\x000A" + "Rejoice O shores\x000A" + "Sing O bells\x000A" + "But I with mournful tread\x000A" + "Walk the deck my captain lies\x000A" + "Fallen cold and dead\x000A" + "Summer surprised, coming over the Starnbergersee\x000A" + "With a shower of rain. We stopped in the Colonnade\x000A" + "A very long label, more than 255 characters\x000A" + "Rejoice O shores\x000A" + "Sing O bells\x000A" + "But I with mournful tread\x000A" + "Walk the deck my captain lies\x000A" + "Fallen cold and dead\x000A" + "Summer surprised, coming over the Starnbergersee\x000A" + "With a shower of rain. We stopped in the Colonnade\x000A" + "A very long label, more than 255 characters\x000A" + "Rejoice O shores\x000A" + "Sing O bells\x000A" + "But I with mournful tread\x000A" + "Walk the deck my captain lies\x000A" + "Fallen cold and dead\x000A" + "Summer surprised, coming over the Starnbergersee\x000A" + "With a shower of rain. We stopped in the Colonnade\x000A" + "A very long label, more than 255 characters\x000A" + "Rejoice O shores\x000A" + "Sing O bells\x000A" + "But I with mournful tread\x000A" + "Walk the deck my captain lies\x000A" + "Fallen cold and dead\x000A" + "Summer surprised, coming over the Starnbergersee\x000A" + "With a shower of rain. We stopped in the Colonnade\x000A" + "And sat and drank coffee an talked for an hour\x000A", arial12format);
			s1.addCell(lr);
			
			WritableCellFormat vertical = new WritableCellFormat();
			vertical.setOrientation(Orientation.VERTICAL);
			lr = new Label(0, 26, "Vertical orientation", vertical);
			s1.addCell(lr);
			
			WritableCellFormat plus_90 = new WritableCellFormat();
			plus_90.setOrientation(Orientation.PLUS_90);
			lr = new Label(1, 26, "Plus 90", plus_90);
			s1.addCell(lr);
			
			WritableCellFormat minus_90 = new WritableCellFormat();
			minus_90.setOrientation(Orientation.MINUS_90);
			lr = new Label(2, 26, "Minus 90", minus_90);
			s1.addCell(lr);
			
			lr = new Label(0, 28, "Modified row height");
			s1.addCell(lr);
			s1.setRowView(28, 24 * 20);
			
			lr = new Label(0, 29, "Collapsed row");
			s1.addCell(lr);
			s1.setRowView(29, true);
			
			// Write hyperlinks
			try
			{
				Label l = new Label(0, 30, "Hyperlink to home page");
				s1.addCell(l);
				
				System.Uri url = new System.Uri("http://www.skysof.com");
				WritableHyperlink wh = new WritableHyperlink(0, 30, 8, 31, url);
				s1.addHyperlink(wh);
				
				// The below hyperlink clashes with above
				WritableHyperlink wh2 = new WritableHyperlink(7, 30, 9, 31, url);
				s1.addHyperlink(wh2);
				
				l = new Label(4, 2, "File hyperlink to documentation");
				s1.addCell(l);
				
				System.IO.FileInfo file = new System.IO.FileInfo("docs/index.html");
				wh = new WritableHyperlink(0, 32, 8, 32, file);
				s1.addHyperlink(wh);
				
				// Add a hyperlink to another cell on this sheet
				wh = new WritableHyperlink(0, 34, 8, 34, "Link to another cell", s1, 0, 180, 1, 181);
				s1.addHyperlink(wh);
				
				file = new System.IO.FileInfo("\\\\localhost\\file.txt");
				wh = new WritableHyperlink(0, 36, 8, 36, file);
				s1.addHyperlink(wh);
				
				// Add a very long hyperlink
				url = new System.Uri("http://www.amazon.co.uk/exec/obidos/ASIN/0571058086" + "/qid=1099836249/sr=1-3/ref=sr_1_11_3/202-6017285-1620664");
				wh = new WritableHyperlink(0, 38, 0, 38, url);
				s1.addHyperlink(wh);
			}
			catch (System.UriFormatException e)
			{
				System.Console.Error.WriteLine(e.ToString());
			}
			
			// Write out some merged cells
			Label l2 = new Label(5, 35, "Merged cells", timesBoldUnderline);
			s1.mergeCells(5, 35, 8, 37);
			s1.addCell(l2);
			
			l2 = new Label(5, 38, "More merged cells");
			s1.addCell(l2);
			Range r = s1.mergeCells(5, 38, 8, 41);
			s1.insertRow(40);
			s1.removeRow(39);
			s1.unmergeCells(r);
			
			// Merge cells and center across them
			WritableCellFormat wcf = new WritableCellFormat();
			wcf.setAlignment(Alignment.CENTER);
			l2 = new Label(5, 42, "Centred across merged cells", wcf);
			s1.addCell(l2);
			s1.mergeCells(5, 42, 10, 42);
			
			wcf = new WritableCellFormat();
			wcf.setBorder(Border.ALL, BorderLineStyle.THIN);
			wcf.setBackground(Color.GRAY_25);
			l2 = new Label(3, 44, "Merged with border", wcf);
			s1.addCell(l2);
			s1.mergeCells(3, 44, 4, 46);
			
			// Clash some ranges - the second range will not be added
			// Also merge some cells with two data items in the - the second data
			// item will not be merged
			/*
			l = new Label(5, 16, "merged cells");
			s1.addCell(l);
			
			Label l5 = new Label(7, 17, "this label won't appear");
			s1.addCell(l5);
			s1.mergeCells(5, 16, 8, 18);    
			
			s1.mergeCells(5, 19, 6, 24);
			s1.mergeCells(6, 18, 10, 19);
			*/
			
			WritableFont courier10ptFont = new WritableFont(WritableFont.COURIER, 10);
			WritableCellFormat courier10pt = new WritableCellFormat(courier10ptFont);
			l2 = new Label(0, 49, "Courier fonts", courier10pt);
			s1.addCell(l2);
			
			WritableFont tahoma12ptFont = new WritableFont(WritableFont.TAHOMA, 12);
			WritableCellFormat tahoma12pt = new WritableCellFormat(tahoma12ptFont);
			l2 = new Label(0, 50, "Tahoma fonts", tahoma12pt);
			s1.addCell(l2);
			
			WritableFont.FontName wingdingsFont = WritableFont.createFont("Wingdings 2");
			WritableFont wingdings210ptFont = new WritableFont(wingdingsFont, 10);
			WritableCellFormat wingdings210pt = new WritableCellFormat(wingdings210ptFont);
			l2 = new Label(0, 51, "Bespoke Windgdings 2", wingdings210pt);
			s1.addCell(l2);
			
			WritableCellFormat shrinkToFit = new WritableCellFormat(times12pt);
			shrinkToFit.setShrinkToFit(true);
			l2 = new Label(3, 53, "Shrunk to fit", shrinkToFit);
			s1.addCell(l2);
			
			l2 = new Label(3, 55, "Some long wrapped text in a merged cell", arial12format);
			s1.addCell(l2);
			s1.mergeCells(3, 55, 4, 55);
			
			l2 = new Label(0, 57, "A cell with a comment");
			WritableCellFeatures cellFeatures = new WritableCellFeatures();
			cellFeatures.setComment("the cell comment");
			l2.setCellFeatures(cellFeatures);
			s1.addCell(l2);
			
			l2 = new Label(0, 59, "A cell with a long comment");
			cellFeatures = new WritableCellFeatures();
			cellFeatures.setComment("a very long cell comment indeed that won't " + "fit inside a standard comment box, so a " + "larger comment box is used instead", 5, 6);
			l2.setCellFeatures(cellFeatures);
			s1.addCell(l2);
			
			WritableCellFormat indented = new WritableCellFormat(times12pt);
			indented.setIndentation(4);
			l2 = new Label(0, 61, "Some indented text", indented);
			s1.addCell(l2);
		}
		
		// Adds cells to the specified sheet which test the various border
		// styles
		private void writeBordersSheet(WritableSheet s)
		{
			s.getSettings().setProtected(true);
			
			s.setColumnView(1, 15);
			s.setColumnView(2, 15);
			s.setColumnView(4, 15);
			WritableCellFormat thickLeft = new WritableCellFormat();
			thickLeft.setBorder(Border.LEFT, BorderLineStyle.THICK);
			Label lr = new Label(1, 0, "Thick left", thickLeft);
			s.addCell(lr);
			
			WritableCellFormat dashedRight = new WritableCellFormat();
			dashedRight.setBorder(Border.RIGHT, BorderLineStyle.DASHED);
			lr = new Label(2, 0, "Dashed right", dashedRight);
			s.addCell(lr);
			
			WritableCellFormat doubleTop = new WritableCellFormat();
			doubleTop.setBorder(Border.TOP, BorderLineStyle.DOUBLE);
			lr = new Label(1, 2, "Double top", doubleTop);
			s.addCell(lr);
			
			WritableCellFormat hairBottom = new WritableCellFormat();
			hairBottom.setBorder(Border.BOTTOM, BorderLineStyle.HAIR);
			lr = new Label(2, 2, "Hair bottom", hairBottom);
			s.addCell(lr);
			
			WritableCellFormat allThin = new WritableCellFormat();
			allThin.setBorder(Border.ALL, BorderLineStyle.THIN);
			lr = new Label(4, 2, "All thin", allThin);
			s.addCell(lr);
			
			WritableCellFormat twoBorders = new WritableCellFormat();
			twoBorders.setBorder(Border.TOP, BorderLineStyle.THICK);
			twoBorders.setBorder(Border.LEFT, BorderLineStyle.THICK);
			lr = new Label(6, 2, "Two borders", twoBorders);
			s.addCell(lr);
			
			// Create a cell in the middle of nowhere (out of the grow region)
			lr = new Label(20, 20, "Dislocated cell - after a page break");
			s.addCell(lr);
			
			// Set the orientation and the margins
			s.getSettings().setPaperSize(PaperSize.A3);
			s.getSettings().setOrientation(PageOrientation.LANDSCAPE);
			s.getSettings().setHeaderMargin(2);
			s.getSettings().setFooterMargin(2);
			
			s.getSettings().setTopMargin(3);
			s.getSettings().setBottomMargin(3);
			
			// Add a header and footera
			HeaderFooter header = new HeaderFooter();
			header.getCenter().append("Page Header");
			s.getSettings().setHeader(header);
			
			HeaderFooter footer = new HeaderFooter();
			footer.getRight().append("page ");
			footer.getRight().appendPageNumber();
			s.getSettings().setFooter(footer);
			
			// Add a page break and insert a couple of rows
			s.addRowPageBreak(18);
			s.insertRow(17);
			s.insertRow(17);
			s.removeRow(17);
			
			// Add a page break off the screen
			s.addRowPageBreak(30);
			
			// Add a hidden column
			lr = new Label(10, 1, "Hidden column");
			s.addCell(lr);
			
			lr = new Label(3, 8, "Hidden row");
			s.addCell(lr);
			s.setRowView(8, true);
			
			WritableCellFormat allThickRed = new WritableCellFormat();
			allThickRed.setBorder(Border.ALL, BorderLineStyle.THICK, Color.RED);
			lr = new Label(1, 5, "All thick red", allThickRed);
			s.addCell(lr);
			
			WritableCellFormat topBottomBlue = new WritableCellFormat();
			topBottomBlue.setBorder(Border.TOP, BorderLineStyle.THIN, Color.BLUE);
			topBottomBlue.setBorder(Border.BOTTOM, BorderLineStyle.THIN, Color.BLUE);
			lr = new Label(4, 5, "Top and bottom blue", topBottomBlue);
			s.addCell(lr);
		}
		
		// Write out loads of labels, in order to test the shared string table</summary>
		private void  writeLabelsSheet(WritableSheet ws)
		{
			ws.getSettings().setProtected(true);
			ws.getSettings().setPassword("jxl");
			ws.getSettings().setVerticalFreeze(5);
			
			WritableFont wf = new WritableFont(WritableFont.ARIAL, 12);
			wf.setItalic(true);
			
			WritableCellFormat wcf = new WritableCellFormat(wf);
			
			CellView cv = new CellView();
			cv.setSize(25 * 256);
			cv.setFormat(wcf);
			ws.setColumnView(0, cv);
			ws.setColumnView(1, 15);
			
			for (int i = 0; i < 61; i++)
			{
				Label l1 = new Label(0, i, "Common Label");
				Label l2 = new Label(1, i, "Distinct label number " + i);
				ws.addCell(l1);
				ws.addCell(l2);
			}
			
			// Frig this test record - it appears exactly on the boundary of an SST
			// continue record
			
			Label l3 = new Label(0, 61, "Common Label", wcf);
			Label l4 = new Label(1, 61, "1-1234567890", wcf);
			Label l5 = new Label(2, 61, "2-1234567890", wcf);
			ws.addCell(l3);
			ws.addCell(l4);
			ws.addCell(l5);
			
			for (int i = 62; i < 200; i++)
			{
				Label l1 = new Label(0, i, "Common Label");
				Label l2 = new Label(1, i, "Distinct label number " + i);
				ws.addCell(l1);
				ws.addCell(l2);
			}
			
			// Add in a last label which doesn't take the common format
			wf = new WritableFont(WritableFont.TIMES, 10, WritableFont.BOLD);
			wf.setColor(Color.RED);
			WritableCellFormat wcf2 = new WritableCellFormat(wf);
			wcf2.setWrap(true);
			Label l = new Label(0, 205, "Different format", wcf2);
			ws.addCell(l);

			// Add some labels to column 5 for autosizing
			Label l6 = new Label(5, 2, "A column for autosizing", wcf2);
			ws.addCell(l6);
			l6 = new Label(5, 4, "Another label, longer this time and " +
				"in a different font");
			ws.addCell(l6);

			CellView cf = new CellView();
			cf.setAutosize(true);
			ws.setColumnView(5, cf);
		}
		
		// Test out the formula parser
		private void  writeFormulaSheet(WritableSheet ws)
		{
			// Add some cells to manipulate
			Number nc = new Number(0, 0, 15);
			ws.addCell(nc);

			nc = new Number(0, 1, 16);
			ws.addCell(nc);

			nc = new Number(0, 2, 10);
			ws.addCell(nc);

			nc = new Number(0, 3, 12);
			ws.addCell(nc);

			ws.setColumnView(2, 20);
			WritableCellFormat wcf = new WritableCellFormat();
			wcf.setAlignment(Alignment.RIGHT);
			wcf.setWrap(true);
			CellView cv = new CellView();
			cv.setSize(25 * 256);
			cv.setFormat(wcf);
			ws.setColumnView(3, cv);

			// Add in the formulas
			Formula f = null;
			Label l = null;

			f = new Formula(2, 0, "A1+A2");
			ws.addCell(f);
			l = new Label(3, 0, "a1+a2");
			ws.addCell(l);

			f = new Formula(2, 1, "A2 * 3");
			ws.addCell(f);
			l = new Label(3, 1, "A2 * 3");
			ws.addCell(l);

			f = new Formula(2, 2, "A2+A1/2.5");
			ws.addCell(f);
			l = new Label(3, 2, "A2+A1/2.5");
			ws.addCell(l);

			f = new Formula(2, 3, "3+(a1+a2)/2.5");
			ws.addCell(f);
			l = new Label(3, 3, "3+(a1+a2)/2.5");
			ws.addCell(l);

			f = new Formula(2, 4, "(a1+a2)/2.5");
			ws.addCell(f);
			l = new Label(3, 4, "(a1+a2)/2.5");
			ws.addCell(l);

			f = new Formula(2, 5, "15+((a1+a2)/2.5)*17");
			ws.addCell(f);
			l = new Label(3, 5, "15+((a1+a2)/2.5)*17");
			ws.addCell(l);

			f = new Formula(2, 6, "SUM(a1:a4)");
			ws.addCell(f);
			l = new Label(3, 6, "SUM(a1:a4)");
			ws.addCell(l);

			f = new Formula(2, 7, "SUM(a1:a4)/4");
			ws.addCell(f);
			l = new Label(3, 7, "SUM(a1:a4)/4");
			ws.addCell(l);

			f = new Formula(2, 8, "AVERAGE(A1:A4)");
			ws.addCell(f);
			l = new Label(3, 8, "AVERAGE(a1:a4)");
			ws.addCell(l);

			f = new Formula(2, 9, "MIN(5,4,1,2,3)");
			ws.addCell(f);
			l = new Label(3, 9, "MIN(5,4,1,2,3)");
			ws.addCell(l);

			f = new Formula(2, 10, "ROUND(3.14159265, 3)");
			ws.addCell(f);
			l = new Label(3, 10, "ROUND(3.14159265, 3)");
			ws.addCell(l);

			f = new Formula(2, 11, "MAX(SUM(A1:A2), A1*A2, POWER(A1, 2))");
			ws.addCell(f);
			l = new Label(3, 11, "MAX(SUM(A1:A2), A1*A2, POWER(A1, 2))");
			ws.addCell(l);

			f = new Formula(2, 12, "IF(A2>A1, \"A2 bigger\", \"A1 bigger\")");
			ws.addCell(f);
			l = new Label(3, 12, "IF(A2>A1, \"A2 bigger\", \"A1 bigger\")");
			ws.addCell(l);

			f = new Formula(2, 13, "IF(A2<=A1, \"A2 smaller\", \"A1 smaller\")");
			ws.addCell(f);
			l = new Label(3, 13, "IF(A2<=A1, \"A2 smaller\", \"A1 smaller\")");
			ws.addCell(l);

			f = new Formula(2, 14, "IF(A3<=10, \"<= 10\")");
			ws.addCell(f);
			l = new Label(3, 14, "IF(A3<=10, \"<= 10\")");
			ws.addCell(l);

			f = new Formula(2, 15, "SUM(1,2,3,4,5)");
			ws.addCell(f);
			l = new Label(3, 15, "SUM(1,2,3,4,5)");
			ws.addCell(l);

			f = new Formula(2, 16, "HYPERLINK(\"http://www.skysof.com\", \"SkySof Software Home Page\")");
			ws.addCell(f);
			l = new Label(3, 16, "HYPERLINK(\"http://www.skysof.com\", \"SkySof Software Home Page\")");
			ws.addCell(l);

			f = new Formula(2, 17, "3*4+5");
			ws.addCell(f);
			l = new Label(3, 17, "3*4+5");
			ws.addCell(l);

			f = new Formula(2, 18, "\"Plain text formula\"");
			ws.addCell(f);
			l = new Label(3, 18, "Plain text formula");
			ws.addCell(l);

			f = new Formula(2, 19, "SUM(a1,a2,-a3,a4)");
			ws.addCell(f);
			l = new Label(3, 19, "SUM(a1,a2,-a3,a4)");
			ws.addCell(l);

			f = new Formula(2, 20, "2*-(a1+a2)");
			ws.addCell(f);
			l = new Label(3, 20, "2*-(a1+a2)");
			ws.addCell(l);

			f = new Formula(2, 21, "'Number Formats'!B1/2");
			ws.addCell(f);
			l = new Label(3, 21, "'Number Formats'!B1/2");
			ws.addCell(l);

			f = new Formula(2, 22, "IF(F22=0, 0, F21/F22)");
			ws.addCell(f);
			l = new Label(3, 22, "IF(F22=0, 0, F21/F22)");
			ws.addCell(l);

			f = new Formula(2, 23, "RAND()");
			ws.addCell(f);
			l = new Label(3, 23, "RAND()");
			ws.addCell(l);

			System.Text.StringBuilder buf = new System.Text.StringBuilder();
			buf.Append("'");
			buf.Append(workbook.getSheet(0).getName());
			buf.Append("'!");
			buf.Append(CellReferenceHelper.getCellReference(9, 18));
			buf.Append("*25");
			f = new Formula(2, 24, buf.ToString());
			ws.addCell(f);
			l = new Label(3, 24, buf.ToString());
			ws.addCell(l);

			wcf = new WritableCellFormat(DateFormats.DEFAULT);
			f = new Formula(2, 25, "NOW()", wcf);
			ws.addCell(f);
			l = new Label(3, 25, "NOW()");
			ws.addCell(l);

			f = new Formula(2, 26, "$A$2+A3");
			ws.addCell(f);
			l = new Label(3, 26, "$A$2+A3");
			ws.addCell(l);

			f = new Formula(2, 27, "IF(COUNT(A1:A9,B1:B9)=0,\"\",COUNT(A1:A9,B1:B9))");
			ws.addCell(f);
			l = new Label(3, 27, "IF(COUNT(A1:A9,B1:B9)=0,\"\",COUNT(A1:A9,B1:B9))");
			ws.addCell(l);

			f = new Formula(2, 28, "SUM(A1,A2,A3,A4)");
			ws.addCell(f);
			l = new Label(3, 28, "SUM(A1,A2,A3,A4)");
			ws.addCell(l);

			l = new Label(1, 29, "a1");
			ws.addCell(l);
			f = new Formula(2, 29, "SUM(INDIRECT(ADDRESS(2,29)):A4)");
			ws.addCell(f);
			l = new Label(3, 29, "SUM(INDIRECT(ADDRESS(2,29):A4)");
			ws.addCell(l);

			f = new Formula(2, 30, "COUNTIF(A1:A4, \">=12\")");
			ws.addCell(f);
			l = new Label(3, 30, "COUNTIF(A1:A4, \">=12\")");
			ws.addCell(l);

			f = new Formula(2, 31, "MAX($A$1:$A$4)");
			ws.addCell(f);
			l = new Label(3, 31, "MAX($A$1:$A$4)");
			ws.addCell(l);

			f = new Formula(2, 32, "OR(A1,TRUE)");
			ws.addCell(f);
			l = new Label(3, 32, "OR(A1,TRUE)");
			ws.addCell(l);

			f = new Formula(2, 33, "ROWS(A1:C14)");
			ws.addCell(f);
			l = new Label(3, 33, "ROWS(A1:C14)");
			ws.addCell(l);

			f = new Formula(2, 34, "COUNTBLANK(A1:C14)");
			ws.addCell(f);
			l = new Label(3, 34, "COUNTBLANK(A1:C14)");
			ws.addCell(l);

			f = new Formula(2, 35, "IF(((F1=\"Not Found\")*(F2=\"Not Found\")*(F3=\"\")*(F4=\"\")*(F5=\"\")),1,0)");
			ws.addCell(f);
			l = new Label(3, 35, "IF(((F1=\"Not Found\")*(F2=\"Not Found\")*(F3=\"\")*(F4=\"\")*(F5=\"\")),1,0)");
			ws.addCell(l);

			f = new Formula(2, 36,
				"HYPERLINK(\"http://www.amazon.co.uk/exec/obidos/ASIN/0571058086qid=1099836249/sr=1-3/ref=sr_1_11_3/202-6017285-1620664\",  \"Long hyperlink\")");
			ws.addCell(f);

			f = new Formula(2, 37, "1234567+2699");
			ws.addCell(f);
			l = new Label(3, 37, "1234567+2699");
			ws.addCell(l);

			f = new Formula(2, 38, "IF(ISERROR(G25/G29),0,-1)");
			ws.addCell(f);
			l = new Label(3, 38, "IF(ISERROR(G25/G29),0,-1)");
			ws.addCell(l);

			f = new Formula(2, 39, "SEARCH(\"C\",D40)");
			ws.addCell(f);
			l = new Label(3, 39, "SEARCH(\"C\",D40)");
			ws.addCell(l);

			f = new Formula(2, 40, "#REF!");
			ws.addCell(f);
			l = new Label(3, 40, "#REF!");
			ws.addCell(l);
			
			// Errors
			/*
			f = new Formula(2, 25, "PLOP(15)"); // unknown function
			ws.addCell(f);
			
			f = new Formula(2, 26, "SUM(15,3"); // unmatched parentheses
			ws.addCell(f);
			
			f = new Formula(2, 27, "SUM15,3)"); // missing opening parentheses
			ws.addCell(f);
			
			f = new Formula(2, 28, "ROUND(3.14159)"); // missing args
			ws.addCell(f);
			
			f = new Formula(2, 29, "NONSHEET!A1"); // sheet not found
			ws.addCell(f);
			*/
		}
		
		// Write out the images
		private void  writeImageSheet(WritableSheet ws)
		{
			Label l = new Label(0, 0, "SkySof Software Inc.");
			ws.addCell(l);
			
			WritableImage wi = new WritableImage(0, 3, 5, 7, new System.IO.FileInfo(startupPath + "\\logo.png"));
			ws.addImage(wi);
		
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			startTime = System.DateTime.Now; 
			System.Console.WriteLine("Modifying workbook...");
			string input = startupPath  + "\\test.xls";
            string output = startupPath + "\\new.xls";
			System.IO.FileInfo inputWorkbook = new System.IO.FileInfo(input);
			System.IO.FileInfo outputWorkbook = new System.IO.FileInfo(output);
			Workbook w1 = Workbook.getWorkbook(inputWorkbook);
			WritableWorkbook w2 = Workbook.createWorkbook(outputWorkbook, w1);

			WritableSheet sheet = w2.getSheet("modified");

			WritableCell cell = null;
			CellFormat cf = null;
			Label l = null;
			WritableCellFeatures wcf = null;

			// Change the format of cell B4 to be emboldened
			cell = sheet.getWritableCell(1,3);
			WritableFont bold = new WritableFont(WritableFont.ARIAL, 
				WritableFont.DEFAULT_POINT_SIZE, 
				WritableFont.BOLD);
			cf = new WritableCellFormat(bold);
			cell.setCellFormat(cf);

			// Change the format of cell B5 to be underlined
			cell = sheet.getWritableCell(1,4);
			WritableFont underline = new WritableFont(WritableFont.ARIAL,
				WritableFont.DEFAULT_POINT_SIZE,
				WritableFont.NO_BOLD,
				false,
				UnderlineStyle.SINGLE);
			cf = new WritableCellFormat(underline);
			cell.setCellFormat(cf);

			// Change the point size of cell B6 to be 10 point
			cell = sheet.getWritableCell(1,5);
			WritableFont tenpoint = new WritableFont(WritableFont.ARIAL, 10);
			cf = new WritableCellFormat(tenpoint);
			cell.setCellFormat(cf);

			// Change the contents of cell B7 to read "Label - mod"
			cell = sheet.getWritableCell(1,6);
			if (cell.getType() == CellType.LABEL)
			{
				Label lc = (Label) cell;
				lc.setString(lc.getString() + " - mod");
			}

			// Change cell B10 to display 7 dps
			cell = sheet.getWritableCell(1,9);
			NumberFormat sevendps = new NumberFormat("#.0000000");
			cf = new WritableCellFormat(sevendps);
			cell.setCellFormat(cf);

            
			// Change cell B11 to display in the format 1e4
			cell = sheet.getWritableCell(1,10);
			NumberFormat exp4 = new NumberFormat("0.####E0");
			cf = new WritableCellFormat(exp4);
			cell.setCellFormat(cf);
            
			// Change cell B12 to be normal display
			cell = sheet.getWritableCell(1,11);
			cell.setCellFormat(WritableWorkbook.NORMAL_STYLE);

			// Change the contents of cell B13 to 42
			cell = sheet.getWritableCell(1,12);
			if (cell.getType() == CellType.NUMBER)
			{
				Number n = (Number) cell;
				n.setValue(42);
			}

			// Add 0.1 to the contents of cell B14
			cell = sheet.getWritableCell(1,13);
			if (cell.getType() == CellType.NUMBER)
			{
				Number n = (Number) cell;
				n.setValue(n.getValue() + 0.1);
			}

			// Change the date format of cell B17 to be a custom format
			cell = sheet.getWritableCell(1,16);
			DateFormat df = new DateFormat("dd MMM yyyy HH:mm:ss");
			cf = new WritableCellFormat(df);
			cell.setCellFormat(cf);

			// Change the date format of cell B18 to be a standard format
			cell = sheet.getWritableCell(1,17);
			cf = new WritableCellFormat(DateFormats.FORMAT9);
			cell.setCellFormat(cf);

			// Change the date in cell B19 to be 18 Feb 1998, 11:23:28
			cell = sheet.getWritableCell(1,18);
			if (cell.getType() == CellType.DATE)
			{
				DateTime dt = (DateTime)cell;
				System.Globalization.Calendar cal = new System.Globalization.GregorianCalendar();
				SupportClass.CalendarManager.manager.Set(cal, 1998, 1, 18, 11, 23, 28);
				System.DateTime d = SupportClass.CalendarManager.manager.GetDateTime(cal);
				dt.setDate(ref d);
			}

			// Change the value in B23 to be 6.8.  This should recalculate the 
			// formula
			cell = sheet.getWritableCell(1,22);
			if (cell.getType() == CellType.NUMBER)
			{
				Number n = (Number) cell;
				n.setValue(6.8);
			}

			// Change the label in B30.  This will have the effect of making
			// the original string unreferenced
			cell = sheet.getWritableCell(1, 29);
			if (cell.getType() == CellType.LABEL)
			{
				l = (Label) cell;
				l.setString("Modified string contents");
			}
			// Insert a new row (number 35)
			sheet.insertRow(34);

			// Delete row 38 (39 after row has been inserted)
			sheet.removeRow(38);

			// Insert a new column (J)
			sheet.insertColumn(9);

			// Remove a column (L - M after column has been inserted)
			sheet.removeColumn(11);

			// Remove row 44 (contains a hyperlink), and then insert an empty
			// row just to keep the numbers consistent
			sheet.removeRow(43);
			sheet.insertRow(43);

			// Modify the hyperlinks
			WritableHyperlink []hyperlinks = sheet.getWritableHyperlinks();

			for (int i = 0; i < hyperlinks.Length; i++)
			{
				WritableHyperlink wh = hyperlinks[i];
				if (wh.getColumn() == 1 && wh.getRow() == 39)
				{
					// Change the hyperlink that begins in cell B40 to be a different API
					wh.setURL(new Uri("http://www.skysof.com"));
					
				}
				else if (wh.getColumn() == 1 && wh.getRow() == 40)
				{
					wh.setFile(new System.IO.FileInfo("../excelapi/docs/overview-summary.html"));
				}
				else if (wh.getColumn() == 1 && wh.getRow() == 41)
				{
					wh.setFile(new System.IO.FileInfo("d:/home/excelapi/docs/xl/package-summary.html"));
				}
				else if (wh.getColumn() == 1 && wh.getRow() == 44)
				{
					// Remove the hyperlink at B45
					sheet.removeHyperlink(wh);
				}
			}
            
			// Change the background of cell F31 from blue to red
			WritableCell c = sheet.getWritableCell(5,30);
			WritableCellFormat newFormat = new WritableCellFormat(c.getCellFormat());
			newFormat.setBackground(Color.RED);
			c.setCellFormat(newFormat);

			// Modify the contents of the merged cell
			l = new Label(0, 49, "Modified merged cells");
			sheet.addCell(l);

			// Modify the chart data
			Number n2 = (Number) sheet.getWritableCell(0, 70);
			n2.setValue(9);
            
			n2 = (Number) sheet.getWritableCell(0, 71);
			n2.setValue(10);

			n2 = (Number) sheet.getWritableCell(0, 73);
			n2.setValue(4);

			// Add in a cross sheet formula
			Formula f = new Formula(1, 80, "ROUND(COS(original!B10),2)");
			sheet.addCell(f);

			// Add in a formula from the named cells
			f = new Formula(1, 83, "value1+value2");
			sheet.addCell(f);

			// Add in a function formula using named cells
			f = new Formula(1, 84, "AVERAGE(value1,value1*4,value2)");
			sheet.addCell(f);

			// Copy sheet 1 to sheet 3
			//     w.copySheet(0, "copy", 2);

			// Use the cell deep copy feature
			Label label = new Label(0, 88, "Some copied cells", cf);
			sheet.addCell(label);

			label = new Label(0,89, "Number from B9");
			sheet.addCell(label);

			WritableCell wc = sheet.getWritableCell(1, 9).copyTo(1,89);
			sheet.addCell(wc);

			label = new Label(0, 90, "Label from B4 (modified format)");
			sheet.addCell(label);

			wc = sheet.getWritableCell(1, 3).copyTo(1,90);
			sheet.addCell(wc);

			label = new Label(0, 91, "Date from B17");
			sheet.addCell(label);

			wc = sheet.getWritableCell(1, 16).copyTo(1,91);
			sheet.addCell(wc);

			label = new Label(0, 92, "Boolean from E16");
			sheet.addCell(label);

			wc = sheet.getWritableCell(4, 15).copyTo(1,92);
			sheet.addCell(wc);

			label = new Label(0, 93, "URL from B40");
			sheet.addCell(label);

			wc = sheet.getWritableCell(1, 39).copyTo(1,93);
			sheet.addCell(wc);

			// Add some numbers for the formula copy
			for (int i = 0 ; i < 6; i++)
			{
				Number number = new Number(1,94+i, i + 1 + i/8.0);
				sheet.addCell(number);
			}

			label = new Label(0,100, "Formula from B27");
			sheet.addCell(label);

			wc = sheet.getWritableCell(1, 26).copyTo(1,100);
			sheet.addCell(wc);

			label = new Label(0,101, "A brand new formula");
			sheet.addCell(label);
            
			Formula formula = new Formula(1, 101, "SUM(B94:B96)");
			sheet.addCell(formula);

			label = new Label(0,102, "A copy of it");
			sheet.addCell(label);

			wc = sheet.getWritableCell(1,101).copyTo(1, 102);
			sheet.addCell(wc);

			// Remove the second image from the sheet
			WritableImage wi = sheet.getImage(1);
			sheet.removeImage(wi);

			wi = new WritableImage(1, 116, 2, 9, 
				new System.IO.FileInfo(startupPath + "\\logo.png"));
			sheet.addImage(wi);

			// Add a list data validations
			label = new Label(0, 151, "Added drop down validation");
			sheet.addCell(label);

			Blank b = new Blank(1, 151);
			wcf = new WritableCellFeatures();
			System.Collections.ArrayList al = new System.Collections.ArrayList();
			al.Add("The Fellowship of the Ring");
			al.Add("The Two Towers");
			al.Add("The Return of the King");
			wcf.setDataValidationList(al);
			b.setCellFeatures(wcf);
			sheet.addCell(b);

			// Add a number data validation
			label = new Label(0, 152, "Added number validation 2.718 < x < 3.142");
			sheet.addCell(label);
			b = new Blank(1,152);
			wcf = new WritableCellFeatures();
			wcf.setNumberValidation(2.718, 3.142, SkySof.xl.write.WritableCellFeatures.BETWEEN);
			b.setCellFeatures(wcf);
			sheet.addCell(b);

			// Modify the text in the first cell with a comment
			cell = sheet.getWritableCell(0, 156);
			l = (Label) cell;
			l.setString("Label text modified");

			cell = sheet.getWritableCell(0, 157);
			wcf = cell.getWritableCellFeatures();
			wcf.setComment("modified comment text");

			cell = sheet.getWritableCell(0, 158);
			wcf = cell.getWritableCellFeatures();
			wcf.removeComment();
			w2.write();
			w2.close();
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds";
			System.Console.WriteLine("Created " + output);
            System.Diagnostics.Process.Start(output);
            MessageBox.Show("Created " + output);
		}

		private void Button13_Click(object sender, System.EventArgs e)
		{
	        System.Diagnostics.Process.Start("https://www.regnow.com/softsell/nph-softsell.cgi?item=4459-60");
		}

		private void Button14_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Process.Start("https://www.paypal.com/xclick/business=kusluski@mail.ic.net&item_name=Excel+API+.NET&amount=169.95");
		}

		private void Button15_Click(object sender, System.EventArgs e)
		{
		    //Buy the complete C# source code for namespace SkySof.xl.util which includes classes
            //HTML, XML, and CSV and tweak the code to your liking!
            System.Diagnostics.Process.Start("https://www.paypal.com/xclick/business=kusluski@mail.ic.net&item_name=Excel+API+.NET+C+Sharp+Source+Code&amount=339.95");
		}

		private void Button16_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Process.Start(startupPath + "\\asp.pdf");
		}

		private void Button8_Click(object sender, System.EventArgs e)
		{
			Workbook w; 
			WorkbookSettings ws = new WorkbookSettings(); 
			bool b; 
    
			startTime = System.DateTime.Now; 
    
			b = true; 
    
			if (b) 
			{ 
				//Change some workbook settings to reduce processing time 
				ws.setPropertySets(false); 
				ws.setCellValidationDisabled(true); 
				//ws.setDrawingsDisabled(True) 'if comments are to be recognized drawings cannot be disabled 
				ws.setGCDisabled(true); 
				ws.setIgnoreBlanks(true); 
				ws.setMergedCellChecking(false); 
				ws.setFormulaAdjust(false); 
			} 
    
			// open the Excel workbook 
			w = Workbook.getWorkbook(startupPath + "\\demo.xls", ws); 
    
			//Create HTML Table - Faster than creating Styled HTML Table 
			//but the following are not supported: cell borders, font size, font style (except bold), etc. 
			//Note that tags </HEAD> and <BODY> are NOT produced within 
			//method CreateHtmlTable() 
			System.IO.FileStream s = new System.IO.FileStream(startupPath + "\\test.htm", System.IO.FileMode.Create, System.IO.FileAccess.Write); 
			SkySof.xl.util.Html html = new SkySof.xl.util.Html(w, 0, "A1:C9", true, true, false, false, false, false, true); 
			string st; 
			st = "<HTML>\r\n<HEAD><CENTER><STRONG>Excel API .NET Demo</STRONG></CENTER>"; 
			st = st + "<TITLE>Excel API .NET Demo</TITLE><BR></HEAD><BODY>\r\n"; 
			st = st + html.CreateHtmlTable(); 
			st = st + "</BODY>\r\n</HTML>"; 
			System.IO.StreamWriter osw = new System.IO.StreamWriter(s, System.Text.Encoding.GetEncoding("unicode")); 
			System.IO.StreamWriter bw = new System.IO.StreamWriter(osw.BaseStream, osw.Encoding); 
			bw.Write(st); 
			bw.Flush(); 
			bw.Close(); 
    
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
    
			if (CheckBox1.Checked) 
			{
                webBrowser1.Navigate(startupPath + "\\test.htm"); 
			} 
			else 
			{ 
				System.Diagnostics.Process.Start(startupPath + "\\test.htm"); 
			}  
		}

		private void Button9_Click(object sender, System.EventArgs e)
		{
			//Create HTML File - Faster than creating Styled HTML File 
			//but the following are not supported: cell borders, font size, font style (except bold), etc. 
			Workbook w; 
			WorkbookSettings ws = new WorkbookSettings(); 
			bool b; 
    
			startTime = System.DateTime.Now; 
    
			b = true; 
    
			if (b) 
			{ 
				//Change some workbook settings to reduce processing time 
				ws.setPropertySets(false); 
				ws.setCellValidationDisabled(true); 
				//ws.setDrawingsDisabled(True) 'if comments are to be recognized drawings cannot be disabled 
				ws.setGCDisabled(true); 
				ws.setIgnoreBlanks(true); 
				ws.setMergedCellChecking(false); 
				ws.setFormulaAdjust(false); 
			} 
			w = Workbook.getWorkbook(startupPath + "\\demo.xls"); 
			SkySof.xl.util.Html html = new SkySof.xl.util.Html(w, 0, "A1:C9", true, true, false, false, true, true, true); 
			html.CreateHtmlFile(startupPath + "\\test.htm", "My HTML File", "My HTML File"); 
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
			if (CheckBox1.Checked) 
			{ 
				webBrowser1.Navigate(startupPath + "\\test.htm"); 
			} 
			else 
			{ 
				System.Diagnostics.Process.Start(startupPath + "\\test.htm"); 
			} 		
		}

		private void Button12_Click(object sender, System.EventArgs e)
		{
			Workbook w; 
			WorkbookSettings ws = new WorkbookSettings(); 
			bool b; 
    
			startTime = System.DateTime.Now; 
    
			b = true; 
    
			if (b) 
			{ 
				//Change some workbook settings to reduce processing time 
				ws.setPropertySets(false); 
				ws.setCellValidationDisabled(true); 
				//ws.setDrawingsDisabled(True) 'if comments are to be recognized drawings cannot be disabled 
				ws.setGCDisabled(true); 
				ws.setIgnoreBlanks(true); 
				ws.setMergedCellChecking(false); 
				ws.setFormulaAdjust(false); 
			} 
    
			// open the Excel workbook 
			w = Workbook.getWorkbook(startupPath + "\\demo.xls", ws); 
    
			//Create Styled HTML Table, slower than CreateHtmlTable but closer 
			//in appearance to Excel 
			//Note that tags </HEAD> and <BODY> are produced within 
			//method CreateStyledHtmlTable() 
			System.IO.FileStream s = new System.IO.FileStream(startupPath + "\\test.htm", System.IO.FileMode.Create, System.IO.FileAccess.Write);
            SkySof.xl.util.Html html = new SkySof.xl.util.Html(w, 0, "A1:C9", true, true, false, false, true, true, true); 
			string st; 
			st = "<HTML>\r\n<HEAD><CENTER><STRONG>Excel API .NET Demo</STRONG></CENTER>"; 
			st = st + "<TITLE>Excel API .NET Demo</TITLE><BR>\r\n"; 
			st = st + html.CreateStyledHtmlTable(); 
			st = st + "</BODY>\r\n</HTML>"; 
			System.IO.StreamWriter osw = new System.IO.StreamWriter(s, System.Text.Encoding.GetEncoding("unicode")); 
			System.IO.StreamWriter bw = new System.IO.StreamWriter(osw.BaseStream, osw.Encoding); 
			bw.Write(st); 
			bw.Flush(); 
			bw.Close(); 
    
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
    
			if (CheckBox1.Checked) 
			{ 
				webBrowser1.Navigate(startupPath + "\\test.htm"); 
			} 
			else 
			{ 
				System.Diagnostics.Process.Start(startupPath + "\\test.htm"); 
			} 		
		}

		private void Button11_Click(object sender, System.EventArgs e)
		{ 
			//Create Styled HTML File, slower than CreateHtmlFile but closer 
			//in appearance to Excel 
			Workbook w; 
			WorkbookSettings ws = new WorkbookSettings(); 
			bool b; 
    
			startTime = System.DateTime.Now; 
    
			b = true; 
    
			if (b) 
			{ 
				//Change some workbook settings to reduce processing time 
				ws.setPropertySets(false); 
				ws.setCellValidationDisabled(true); 
				//ws.setDrawingsDisabled(True) 'if comments are to be recognized drawings cannot be disabled 
				ws.setGCDisabled(true); 
				ws.setIgnoreBlanks(true); 
				ws.setMergedCellChecking(false); 
				ws.setFormulaAdjust(false); 
			} 
			w = Workbook.getWorkbook(startupPath + "\\demo.xls");
            SkySof.xl.util.Html html = new SkySof.xl.util.Html(w, 0, "A1:C9", true, true, false, false, true, true, true); 
			html.CreateStyledHtmlFile(startupPath + "\\test.htm", "My HTML File", "My HTML File"); 
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
			if (CheckBox1.Checked) 
			{ 
				webBrowser1.Navigate(startupPath + "\\test.htm"); 
			} 
			else 
			{ 
				System.Diagnostics.Process.Start(startupPath + "\\test.htm"); 
			} 		
		}

		private void Button4_Click(object sender, System.EventArgs e)
		{
			Workbook w = null; 
    
			startTime = System.DateTime.Now; 
    
			// open the Excel workbook 
			w = Workbook.getWorkbook(startupPath + "\\demo.xls"); 
    
			//The file stream to write to 
			System.IO.FileStream s = new System.IO.FileStream(startupPath + "\\test.csv", System.IO.FileMode.Create, System.IO.FileAccess.Write); 
    
			//Valid encoding parameter values: ASCII,Unicode,UTF-8 
			SkySof.xl.util.CSV dm = new SkySof.xl.util.CSV(w, s, "Unicode", false, false); 
    
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
			System.Diagnostics.Process.Start(startupPath + "\\test.csv"); 
		}

		private void Button6_Click(object sender, System.EventArgs e)
		{
			Workbook w = null; 
    
			startTime = System.DateTime.Now; 
    
			bool useSystemData = true; 
    
			if (useSystemData == false) 
			{ 
        
				// open the Excel workbook 
				w = Workbook.getWorkbook(startupPath + "\\demo.xls"); 
        
				//The file stream to write to 
				System.IO.FileStream s = new System.IO.FileStream(startupPath + "\\test.xml", System.IO.FileMode.Create, System.IO.FileAccess.Write); 
        
				//Valid encoding parameter values: ASCII,Unicode,UTF-8 
				SkySof.xl.util.XML dm = new SkySof.xl.util.XML(w, s, "unicode", true, string.Empty); 
        
				w.close(); 
			} 
    
			else 
			{ 
        
				//excelVersion argument 
				//5 = Excel 95 and earlier 
				//8 = Excel 97 and above 
				//12 = Excel 2007 
				System.String ver = "8";
				SkySof.xl.util.XML dm = new SkySof.xl.util.XML(startupPath + "\\demo.xls", "sheet1", "a1:c9", startupPath + "\\test.xml", false, true, true, ver);
                //Code below uses a range name 'range1', you could also use A1:C9
                //SkySof.xl.util.XML dm = new SkySof.xl.util.XML(startupPath + "\\demo.xls", "range1", startupPath + "\\test.xml", false, true, true, ver); 
        
			} 
    
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
			if (CheckBox1.Checked) 
			{ 
				webBrowser1.Navigate(startupPath + "\\test.xml"); 
			} 
			else 
			{ 
				System.Diagnostics.Process.Start(startupPath + "\\test.xml"); 
			} 		
		}

		private void button10_Click(object sender, System.EventArgs e)
		{
			string s; 
    
			// check the input parameters 
			string filename = startupPath + "\\demo.xls"; 
    
			// init 
			Workbook workbook = null; 
    
			// open the Excel workbook 
			workbook = Workbook.getWorkbook(filename); 
    
			// for each sheet in workbook, write cell contents to console 
			foreach (Sheet sheet in workbook.getSheets()) 
			{ 
				for (int irow = 0; irow <= sheet.getRows() - 1; irow++) 
				{ 
					// for each row 
					for (int icol = 0; icol <= sheet.getColumns() - 1; icol++) 
					{ 
						// for each column 
						// get current cell 
						SkySof.xl.Cell cell = sheet.getCell(icol, irow); 
                
						if (cell.getType() == CellType.EMPTY | cell.getType() == CellType.ERROR) 
						{ 
						} 
							//skip 
						else 
						{ 
                    
							s = ""; 
                    
							if (cell.getType() == CellType.NUMBER_FORMULA | cell.getType() == CellType.STRING_FORMULA | cell.getType() == CellType.BOOLEAN_FORMULA | cell.getType() == CellType.DATE_FORMULA | cell.getType() == CellType.FORMULA_ERROR) 
							{ 
								SkySof.xl.FormulaCell nfc = (SkySof.xl.FormulaCell)cell; 
								s = "Formula: " + nfc.getFormula() + "\r\n"; 
							} 
                    
							SkySof.xl.CellFeatures cf = cell.getCellFeatures(); 
                    
							CellFormat cfm = cell.getCellFormat(); 
							s = s + "Contents: " + cell.getContents() + "\r\n"; 
							s = s + "Type: " + cell.getType().ToString() + "\r\n"; 
							s = s + "Pattern: " + cfm.getPattern().getValue() + "\r\n"; 
							s = s + "IsLocked: " + cfm.isLocked().ToString() + "\r\n"; 
							s = s + "BackgroundColor: " + cfm.getBackgroundColor().getValue().ToString() + "\r\n"; 
							s = s + "FormatString: " + cfm.getFormat().getFormatString() + "\r\n"; 
							s = s + "Alignment: " + cfm.getAlignment().getValue().ToString() + "\r\n"; 
							s = s + "Border Top: " + cfm.getBorder(Border.TOP).getValue() + "\r\n"; 
							s = s + "Border Bottom: " + cfm.getBorder(Border.BOTTOM).getValue() + "\r\n"; 
							s = s + "Border Top Color: " + cfm.getBorderColor(Border.TOP).getValue() + "\r\n"; 
							s = s + "Border Bottom Color: " + cfm.getBorderColor(Border.BOTTOM).getValue() + "\r\n"; 
							s = s + "Font BoldWeight: " + cfm.getFont().getBoldWeight().ToString() + "\r\n"; 
							s = s + "Font Name: " + cfm.getFont().getName().ToString() + "\r\n"; 
							s = s + "Font Color: " + cfm.getFont().getColor().getValue().ToString() + "\r\n"; 
							s = s + "Font Size: " + cfm.getFont().getPointSize().ToString() + "\r\n"; 
							s = s + "Font Script Style: " + cfm.getFont().getScriptStyle().getValue().ToString() + "\r\n"; 
							s = s + "Font Underline Style: " + cfm.getFont().getUnderlineStyle().getValue().ToString() + "\r\n"; 
							s = s + "Font isItalic: " + cfm.getFont().isItalic().ToString() + "\r\n"; 
							s = s + "Font isStruckout: " + cfm.getFont().isStruckout().ToString() + "\r\n"; 
							s = s + "Indentation: " + cfm.getIndentation().ToString() + "\r\n"; 
							s = s + "Orientation: " + cfm.getOrientation().getValue().ToString() + "\r\n"; 
							s = s + "VerticalAlignment: " + cfm.getVerticalAlignment().getValue().ToString() + "\r\n"; 
							s = s + "getWrap: " + cfm.getWrap().ToString() + "\r\n"; 
							s = s + "hasBorders: " + cfm.hasBorders().ToString()+ "\r\n"; 
							s = s + "isShrinkToFit: " + cfm.isShrinkToFit().ToString() + "\r\n"; 
             
						    MessageBox.Show(s, "Sheet: " + sheet.getName() + ", Row: " + irow + ", Col: " + icol);
                    
							// write to console the cell contents 
							System.Console.WriteLine("{0}[{1},{2}]: {3}", sheet.getName().ToString(), irow, icol, cell.getContents()); 
                    
						} 
					} 
				} 
        
			} 
			// Close workbook 
			if ((workbook != null)) 
			{ 
				workbook.close(); 
			} 
		}

		private void button7_Click(object sender, System.EventArgs e)
		{
			Workbook w = null; 
    
			startTime = System.DateTime.Now; 
    
			// open the Excel workbook 
			w = Workbook.getWorkbook(startupPath + "\\demo.xls"); 
    
			//The file stream to write to 
			System.IO.FileStream s = new System.IO.FileStream(startupPath + "\\escher.txt", System.IO.FileMode.Create, System.IO.FileAccess.Write); 
    
			//Valid encoding parameter values: ASCII,Unicode,UTF-8 
			SkySof.xl.util.Escher dm = new SkySof.xl.util.Escher(w, s, "Unicode"); 
    
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
			System.Diagnostics.Process.Start(startupPath + "\\escher.txt"); 
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			Workbook w = null; 
    
			startTime = System.DateTime.Now; 
    
			// open the Excel workbook 
			w = Workbook.getWorkbook(startupPath + "\\demo.xls"); 
    
			//The file stream to write to 
			System.IO.FileStream s = new System.IO.FileStream(startupPath + "\\escherdrawing.txt", System.IO.FileMode.Create, System.IO.FileAccess.Write); 
    
			//Valid encoding parameter values: ASCII,Unicode,UTF-8 
			SkySof.xl.util.EscherDrawingGroup dm = new SkySof.xl.util.EscherDrawingGroup(w, s, "Unicode"); 
    
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
			System.Diagnostics.Process.Start(startupPath + "\\escherdrawing.txt"); 
		}

		private void Button5_Click(object sender, System.EventArgs e)
		{
			//The Excel file to read 
			System.IO.FileInfo xl = new System.IO.FileInfo(startupPath + "\\demo.xls"); 
    
			startTime = System.DateTime.Now; 
    
			//The file stream to write to 
			System.IO.FileStream s = new System.IO.FileStream(startupPath + "\\biff.txt", System.IO.FileMode.Create, System.IO.FileAccess.Write); 
    
			SkySof.xl.util.BiffDump dm = new SkySof.xl.util.BiffDump(xl, s); 
    
			StatusBar1.Text = System.DateTime.Now.Subtract(startTime) + " seconds"; 
			System.Diagnostics.Process.Start(startupPath + "\\biff.txt"); 
		}

        private void Button17_Click(object sender, EventArgs e)
        {
            System.Data.OleDb.OleDbConnection objConn = new System.Data.OleDb.OleDbConnection();
            System.Data.OleDb.OleDbDataAdapter objDataAdapter = null;
            string s;
            SkySof.xl.util.Data data = new SkySof.xl.util.Data();
            //Can use range names or Sheet and range 
            //s = "SELECT * FROM [MyRange]" 
            s = "SELECT * FROM [Sheet1$A12:C16]";
            startTime = System.DateTime.Now;
            data.ExcelToDataAdapter(startupPath + "\\demo.xls", s, objConn, ref objDataAdapter, true, true, 11);
            StatusBar1.Text = System.DateTime.Now.Subtract(startTime).ToString() + " seconds";
            DataSet objDS = new DataSet("authors");
            objDataAdapter.Fill(objDS, "names");
            objConn.Close();
            //note that the connection object is closed 
            DataTable objTable;
            //get data table from dataset 
            objTable = objDS.Tables["names"];
            //DataRow objRow; 
            //DataColumn objColumn; 
            //display field names 
            s = "";
            foreach (DataColumn objColumn in objTable.Columns)
            {
                s += objColumn.ColumnName + "\t";
            }
            s += "\r\n";
            //display all data 
            foreach (DataRow objRow in objTable.Rows)
            {
                foreach (DataColumn objColumn in objTable.Columns)
                {
                    s += objRow[objColumn] + "\t";
                }
                s += "\r\n";
            }
            MessageBox.Show(s, "ExcelToDataAdapter");
            objConn = null; 
        }

        private void Button18_Click(object sender, EventArgs e)
        {
            System.Data.OleDb.OleDbConnection objConn = new System.Data.OleDb.OleDbConnection();
            string s;
            //Can use range names or Sheet and range 
            //s = "SELECT * FROM [MyRange]" 
            s = "SELECT * FROM [Sheet1$A12:C16]";
            System.Data.OleDb.OleDbDataReader objReader = null;
            int n;
            SkySof.xl.util.Data data = new SkySof.xl.util.Data();
            startTime = System.DateTime.Now;
            data.ExcelToDataReader(startupPath + "\\demo.xls", s, objConn, ref objReader, true, true, 11);
            StatusBar1.Text = System.DateTime.Now.Subtract(startTime).ToString() + " seconds";
            s = "";
            int cols = objReader.FieldCount - 1;
            for (n = 0; n <= cols; n++)
            {
                s += objReader.GetName(n) + "\t";
            }
            s += "\r\n";
            while (objReader.Read())
            {
                for (n = 0; n <= cols; n++)
                {
                    switch (objReader[n].ToString())
                    {
                        case "Date":
                            s += objReader.GetDateTime(n).ToShortDateString() + "\t";
                            break;
                        default:
                            s += objReader[n].ToString() + "\t";
                            break;
                    }
                }
                s += "\r\n";
            }
            MessageBox.Show(s, "ExcelToDataReader");
            objReader.Close();
            objConn.Close();
            objReader = null;
            objConn = null; 
        }

        private void button19_Click(object sender, EventArgs e)
        {
            Workbook w;
            WorkbookSettings ws = new WorkbookSettings();
            bool b;

            b = true;

            if (b)
            {
                //Change some workbook settings to reduce processing time 
                ws.setPropertySets(false);
                ws.setCellValidationDisabled(true);
                //ws.setDrawingsDisabled(True) 'if comments are to be recognized drawings cannot be disabled 
                ws.setGCDisabled(true);
                ws.setIgnoreBlanks(true);
                ws.setMergedCellChecking(false);
                ws.setFormulaAdjust(false);
            }

            //open the Excel workbook 
            w = Workbook.getWorkbook(startupPath + "\\demo.xls", ws);

            //store cell data to ArrayList 
            SkySof.xl.util.Collections data = new SkySof.xl.util.Collections(w, 0, "a1:c9");
            ArrayList al = data.getArrayList(true, false);

            //display the stored data 
            string s = null;
            for (int i = 0; i <= al.Count - 1; i++)
            {
                s = s + "Item " + (i + 1) + ": " + al[i] + "\r\n";
            }
            MessageBox.Show(s, al.Count.ToString() + " ArrayList Items");

            //store cell data to a Hashtable 
            Hashtable ht = data.getHashtable(true, false);

            //display the stored data 
            s = null;
            foreach (string key in ht.Keys)
            {
                s = s + "Key: " + key + ", " + " Value: " + ht[key] + "\r\n";
            }
            MessageBox.Show(s, ht.Count.ToString() + " Hashtable Items");

            //store cell data to a SortedList 
            SortedList sl = data.getSortedList(true, false);

            //display the stored data 
            s = null;
            foreach (string key in sl.Keys)
            {
                s = s + "Key: " + key + ", " + " Value: " + sl[key] + "\r\n";
            }
            MessageBox.Show(s, sl.Count.ToString() + " SortedList Items");
            //MessageBox.Show(sl.GetByIndex(2).ToString(), "Get SortedList Item by Index"); 
            //MessageBox.Show(sl.GetKey(2).ToString(), "Get SortedList Key by Index");

            //store cell data to a Stack (LIFO) 
            Stack st = data.getStack(true, false);

            //display the stored data 
            s = null;
            int stackCount = st.Count;
            while (st.Count != 0)
            {
                s = s + "Value: " + st.Pop() + "\r\n";
            }
            MessageBox.Show(s, stackCount.ToString() + " Stack Items (LIFO)");

            //store cell data to a Queue (FIFO) 
            Queue qu = data.getQueue(true, false);

            //display the stored data 
            s = null;
            int queueCount = qu.Count;
            while (qu.Count != 0)
            {
                s = s + "Value: " + qu.Dequeue() + "\r\n";
            }
            MessageBox.Show(s, queueCount.ToString() + " Queue Items (FIFO)");

            //store cell data to a String Collection 
            System.Collections.Specialized.StringCollection sv = data.getStringValues(true, false);

            //display the stored data 
            s = null;
            for (int i = 0; i <= sv.Count - 1; i++)
            {
                s = s + "Item " + (i + 1) + ": " + sv[i] + "\r\n";
            }
            MessageBox.Show(s, queueCount.ToString() + " StringCollection Items");

            //store cell data to a SortedList 
            System.Collections.Specialized.StringDictionary sd = data.getStringDictionary(true, false);

            //display the stored data 
            s = null;
            foreach (string key in sd.Keys)
            {
                s = s + "Key: " + key + ", " + " Value: " + sd[key] + "\r\n";
            }
            MessageBox.Show(s, sd.Count.ToString() + " StringDictionary Items"); 

        }

        private void button20_Click(object sender, EventArgs e)
        {
            ListViewItem lItem;
            string filename = startupPath + "\\demo.xls";
            string s;

            // init 
            Workbook workbook = null;
            SkySof.xl.Cell cell;
            int row;

            startTime = System.DateTime.Now;

            ListView1.Clear();

            // open the Excel workbook 
            workbook = Workbook.getWorkbook(filename);

            // for each sheet in workbook, write cell contents to console 
            Sheet sheet = workbook.getSheet(0);

            ListView1.View = View.Details;

            ListView1.Columns.Add("", 10, HorizontalAlignment.Center);
            ListView1.Columns.Add("A", 100, HorizontalAlignment.Left);
            ListView1.Columns.Add("B", 100, HorizontalAlignment.Left);
            ListView1.Columns.Add("C", 100, HorizontalAlignment.Left);

            for (int irow = 0; irow <= 8; irow++)
            {
                row = irow + 1;
                lItem = ListView1.Items.Add(row.ToString());
                for (int icol = 0; icol <= 2; icol++)
                {
                    cell = sheet.getCell(icol, irow);
                    s = cell.getContents();
                    lItem.SubItems.Add(s);
                }
            }

            StatusBar1.Text = System.DateTime.Now.Subtract(startTime).ToString() + " seconds"; 

            workbook.close();
            workbook = null; 
        } 
	}
}
